#include "6502macros.h"

.section .iwram,"ax",%progbits
.align 4
.code 32

.global endScanline
endScanline:
  doCycles 0
  
.global _xx
.type _xx,function
_xx:   @NOP
#if 0
  stmfd sp!,{r0-r12}
  ldr     r4,=dumpOp
  sub     r1,bbc_pc,bbc_mem
  adr     lr,1f
  bx      r4
1:
  ldmfd sp!,{r0-r12}
#endif
  doCycles 2
 
#ifdef SHOW_ILLEGAL_OPS
LdumpOp:
.word dumpOp
#endif

@ -------------------------------------	
_01:  @ORA ($nn,X)
  doIIX
  doORA
  doCycles 6

@ -------------------------------------
_05: @ORA $nn   
  doZ
  doORA
  doCycles 2
@ -------------------------------------
_06: @ASL $nn
  doZ
	doASL
	doCycles 5
@ -------------------------------------
_08:   @PHP
	encodeP (B+R)
	push8 r0
	doCycles 3
@ -------------------------------------
_09:   @ORA #$nn
	doIMM
	doORA
	doCycles 2
@ -------------------------------------
_0A:  @   ASL
  adds bbc_a,bbc_a,bbc_a
  orr bbc_nz,bbc_a,bbc_a,lsr#24
  mrs bbc_c,cpsr
  doCycles 2
@ -------------------------------------
_0D:  @   ORA $nnnn
  doABS
  doORA
  doCycles 4
@ -------------------------------------
_0E:  @   ASL $nnnn
  doABS
  doASL
  doCycles 6
@ -------------------------------------
_10x:     @   BPL
  orr bbc_cycles,bbc_cycles,#BRANCH
_10:
  tst bbc_nz,#0x80000000
  ldrsb r0,[bbc_pc],#1
  addeq bbc_pc,bbc_pc,r0
  subeq bbc_cycles,bbc_cycles,#1 @#3*CYCLE
  doCycles 2
@ -------------------------------------
_11:  @   ORA ($nn),Y
  doIIY
  doORA
  doCycles 5
@ -------------------------------------
_15:  @   ORA $nn,X
  doZIX
  doORA
  doCycles 4
@ -------------------------------------
_16:  @   ASL $nn,X
  doZIX
  doASL
  doCycles 6
@ -------------------------------------
_18:  @   CLC
  mov bbc_c,#0
  doCycles 2
@ -------------------------------------
_19:  @   ORA $nnnn,Y
  doAIY
  doORA
  doCycles 4
@ -------------------------------------
_1D:  @   ORA $nnnn,X
  doAIX
  doORA
  doCycles 4
@ -------------------------------------
_1E:  @   ASL $nnnn,X
  doAIX
  doASL
  doCycles 7
@ -------------------------------------
_20:  @   JSR $nnnn
  ldrb r2,[bbc_pc],#1        @r2 = mem[pc + 1]
@  ldr r1,lastbank           @r1 = lastbank
  sub r0,bbc_pc,bbc_mem      @r0 = pc - mem addr
  ldrb r1,[bbc_pc]          @r1 = mem[pc + 1]
  orr bbc_pc,r2,r1,lsl#8    @ bbc_pc = r2|r1<<8
  push16
  encodePC
  doCycles 6
@ -------------------------------------
_21:  @   AND ($nn,X)
  doIIX
  doAND
  doCycles 6
@ -------------------------------------
_24:  @   BIT $nn
  doZ
  doBIT
  doCycles 3
@ -------------------------------------
_25:  @   AND $nn
  doZ
  doAND
  doCycles 3
@ -------------------------------------
_26:  @   ROL $nn
  doZ
  doROL
  doCycles 5
@ -------------------------------------
_28:  @   PLP
  pop8 r0
  decodeP
  doCycles 4
@ -------------------------------------
_29:  @   AND #$nn
  doIMM
  doAND
  doCycles 2
@ -------------------------------------
.type _2A,function
_2A:  @   ROL ACC
  msr cpsr_f,bbc_c    @get C
  orrcs bbc_a,bbc_a,#0x00800000
  adds bbc_a,bbc_a,bbc_a
  mov bbc_nz,bbc_a,asr#24 @NZ
  mrs bbc_c,cpsr        @C
  doCycles 2
@ -------------------------------------
.type _2C,function
_2C:  @   BIT $nnnn
  doABS
  doBIT
  doCycles 4
@ -------------------------------------
_2D:  @   AND $nnnn
  doABS
  doAND
  doCycles 4
@ -------------------------------------
_2E:  @   ROL $nnnn
  doABS
  doROL
  doCycles 6
@ -------------------------------------
_30x:   @   BMI
  orr bbc_cycles,bbc_cycles,#BRANCH
_30:
  tst bbc_nz,#0x80000000
  ldrsb r0,[bbc_pc],#1
  addne bbc_pc,bbc_pc,r0
  subne bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2
@ -------------------------------------
_31:  @   AND ($nn),Y
  doIIY
  doAND
  doCycles 5
@ -------------------------------------
_35:  @   AND $nn,X
  doZIX
  doAND
  doCycles 4
@ -------------------------------------
_36:  @   ROL $nn,X
  doZIX
  doROL
  doCycles 6
@ -------------------------------------
.type _38,function
_38:  @   SEC
  mov bbc_c,#PSR_C
  doCycles 2
@ -------------------------------------
_39:  @   AND $nnnn,Y
@ -------------------------------------
  doAIY
  doAND
  doCycles 4
@ -------------------------------------
_3D:  @   AND $nnnn,X
@ -------------------------------------
  doAIX
  doAND
  doCycles 4
@ -------------------------------------
_3E:  @   ROL $nnnn,X
@ -------------------------------------
  doAIX
  doROL
  doCycles 7
@ -------------------------------------
.type _40,function
_40:  @   RTI
  pop8 r0       @pop 6502 flags and decode
  orr   r0,r0,#B
  decodeP
  pop16         @pop the return address
  encodePC
#ifdef DEBUG
  @ isInINT is now 0
  ldr   r0,LisInINT
  mov   r1,#0
  str   r1,[r0]  
#endif
  doCycles 6

#ifdef DEBUG
LisInINT:
.word isInINT
#endif

@ -------------------------------------
_41:  @   EOR ($nn,X)
  doIIX
  doEOR
  doCycles 6
@ -------------------------------------
_45:  @   EOR $nn
  doZ
  doEOR
  doCycles 3
@ -------------------------------------
_46:  @   LSR $nn
  doZ
  doLSR
  doCycles 5
@ -------------------------------------
_48:  @   PHA
  mov r0,bbc_a,lsr#24
  push8 r0
  doCycles 3
@ -------------------------------------
_49:  @   EOR #$nn
  doIMM
  doEOR
  doCycles 2
@ -------------------------------------
_4A:  @   LSR
  movs bbc_nz,bbc_a,lsr#25  @Z
  mov bbc_a,bbc_nz,lsl#24
  mrs bbc_c,cpsr      @C
  doCycles 2
@ -------------------------------------
.type _4C,function
_4C:  @   JMP $nnnn
  ldrb r0,[bbc_pc],#1
  ldrb r1,[bbc_pc]
  orr bbc_pc,r0,r1,lsl#8
  encodePC
  doCycles 3
@ -------------------------------------
@ what the hell is all this?
_4Cx: @   JMP $nnnn
  ldrb r0,[bbc_pc],#1
  ldrb r1,[bbc_pc]
  orr bbc_pc,r0,r1,lsl#8
  tst bbc_cycles,#BRANCH
  beq checkdeadloop                   @ branch if cycles & 1 == 0
  bic bbc_cycles,bbc_cycles,#BRANCH   @ otherwise clear bit 1 from cycles
fini:
  encodePC
  doCycles 3
checkdeadloop:     @if thisjumpaddr=lastjumpaddr, cycles=0
    ldr memptr,lastjump
    cmp memptr,bbc_pc
    moveq bbc_cycles,#0
    strne bbc_pc,lastjump
    b fini
lastjump: .space 4
@ -------------------------------------
_4D:  @   EOR $nnnn
  doABS
  doEOR
  doCycles 4
@ -------------------------------------
_4E:  @   LSR $nnnn
  doABS
  doLSR
  doCycles 6
@ -------------------------------------
_50x:   @BVC
  orr bbc_cycles,bbc_cycles,#BRANCH

.type _50,function
_50:
  ldr r0,bbc_v
  tst r0,#PSR_V
  ldrsb r0,[bbc_pc],#1
  addeq bbc_pc,bbc_pc,r0
  subeq bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2
@ -------------------------------------
_51:  @   EOR ($nn),Y
  doIIY
  doEOR
  doCycles 5
@ -------------------------------------
_55:  @   EOR $nn,X
  doZIX
  doEOR
  doCycles 4
@ -------------------------------------
_56:  @   LSR $nn,X
  doZIX
  doLSR
  doCycles 6
@ -------------------------------------
.type _58,function
_58:  @   CLI
  ldr r0,bbc_di
  bic r0,r0,#I
  str r0,bbc_di
  @ need to check interrupts here cos I
  @ can't really do it after every instruction
  doInterruptCheck


  doCycles 2
 .pool
@ -------------------------------------
_59:  @   EOR $nnnn,Y
  doAIY
  doEOR
  doCycles 4
@ -------------------------------------
_5D:  @   EOR $nnnn,X
  doAIX
  doEOR
  doCycles 4
@ -------------------------------------
_5E:  @   LSR $nnnn,X
  doAIX
  doLSR
  doCycles 7
@ -------------------------------------
.type _60,function
_60:  @   RTS
  pop16
  add bbc_pc,bbc_pc,#1
  encodePC
  doCycles 6
@ -------------------------------------
_61:  @   ADC ($nn,X)
  doIIX
  doCompleteADC 6
@  doADC
@  doCycles 6
@ -------------------------------------
_65:  @   ADC $nn
  doZ
  doCompleteADC 3
@  doADC
@  doCycles 3
@ -------------------------------------
_66:  @   ROR $nn
  doZ
  doROR
  doCycles 5
@ -------------------------------------
_68:  @   PLA
  pop8 bbc_nz
  mov bbc_a,bbc_nz,lsl#24
  doCycles 4
@ -------------------------------------
_69:  @   ADC #$nn
  doIMM
  doCompleteADC 2
@  doADC
@  doCycles 2
@ -------------------------------------
_6A:  @   ROR
  msr cpsr_f,bbc_c
  mov bbc_a,bbc_a,rrx
  movs bbc_nz,bbc_a,asr#24
  and bbc_a,bbc_a,#0xff000000
  mrs bbc_c,cpsr          @C
  doCycles 2
@ -------------------------------------
.type _6C,function
_6C:  @   JMP ($nnnn)       i.e. jump to the value held in nnnn and nnnn+1
  doABS         @ memptr holds $nnnn -> VectorLocation
@  adr r1,memmap_tbl           @ r1 = &memmap_tbl
@  and r2,memptr,#0xE000       @ r2 = memptr&0xe000
@  ldr r1,[r1,r2,lsr#11]       @ r1 = memmap_tbl[(memptr&0xe000)>>11]
@  ldr  r1,0f
  ldrb bbc_pc,[bbc_mem,memptr]       @ pc = bbc_mem[memptr]
  add memptr,memptr,#1            @ memptr++
  @sub memptr,memptr,#0xff            @ memptr-255
  ldrb r0,[bbc_mem,memptr]             @ r0 = bbc_mem[memptr+1]
  orr bbc_pc,bbc_pc,r0,lsl#8      @ pc = bbc_mem[memptr]|bbc_mem[memptr+1]<<8
  encodePC
  doCycles 5

@0:
@.word WholeRam

@ -------------------------------------
_6D:  @   ADC $nnnn
  doABS
  doCompleteADC 4
@  doADC
@  doCycles 4
@ -------------------------------------
_6E:  @   ROR $nnnn
  doABS
  doROR
  doCycles 6
@ -------------------------------------
_70x:   @   BVS
  orr bbc_cycles,bbc_cycles,#BRANCH
_70:
  ldr r0,bbc_v
  tst r0,#PSR_V
  ldrsb r0,[bbc_pc],#1
  addne bbc_pc,bbc_pc,r0
  subne bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2
@ -------------------------------------
_71:  @   ADC ($nn),Y
  doIIY
  doCompleteADC 5
@  doADC
@  doCycles 5
@ -------------------------------------
.type _75,function
_75:  @   ADC $nn,X
  doZIX
  doCompleteADC 4
@  ldr   r0,bbc_di
@  tst   r0,#D
@  @ if D set then need to do bcd add
@  @ else do 2s compliment add:
@  bne   bcdADC
@  doADC
@  doCycles 4
@bcdADC:
@  doBCDADC
@  doCycles 4
@ -------------------------------------
_76:  @   ROR $nn,X
  doZIX
  doROR
  doCycles 6
@ -------------------------------------
.type _78, function
_78:  @   SEI
  ldr r0,bbc_di
  orr r1,r0,#I
  str r1,bbc_di
@  doInterruptCheck
  doCycles 2
@ -------------------------------------
_79:  @   ADC $nnnn,Y
  doAIY
  doCompleteADC 4
@  doADC
@  doCycles 4
@ -------------------------------------
_7D:  @   ADC $nnnn,X
  doAIX
  doCompleteADC 4
@  doADC
@  doCycles 4
@ -------------------------------------
.type _7E,function
_7E:  @   ROR $nnnn,X
  doAIX
  doROR
  doCycles 7
@ -------------------------------------
_81:  @   STA ($nn,X)
  doIIX
  doSTORE bbc_a
  doCycles 6
@ -------------------------------------
_84:  @   STY $nn
  doZ
  doSTORE bbc_y
  doCycles 3
@ -------------------------------------
.type _85,function
_85:  @   STA $nn
  doZ
  doSTORE bbc_a
  doCycles 3
@ -------------------------------------
_86:  @   STX $nn
  doZ
  doSTORE bbc_x
  doCycles 3
@ -------------------------------------
_88:  @   DEY
  sub bbc_y,bbc_y,#0x01000000
  mov bbc_nz,bbc_y,asr#24
  doCycles 2
@ -------------------------------------
.type _8A,function
_8A:  @   TXA
  mov bbc_a,bbc_x
  mov bbc_nz,bbc_x,asr#24
  doCycles 2
@ -------------------------------------
.type _8C,function
_8C:  @   STY $nnnn
  doABS
  doSTORE bbc_y
  doCycles 4
@ -------------------------------------
.type _8D, function
_8D:  @   STA $nnnn
  doABS
  doSTORE bbc_a
  doCycles 4
@ -------------------------------------
_8E:  @   STX $nnnn
  doABS
  doSTORE bbc_x
  doCycles 4
@ -------------------------------------
_90x: @   BCC
  orr bbc_cycles,bbc_cycles,#BRANCH
_90:
  tst bbc_c,#PSR_C
  ldrsb r0,[bbc_pc],#1
  addeq bbc_pc,bbc_pc,r0
  subeq bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2
.pool
@ -------------------------------------
_91:  @   STA ($nn),Y
  doIIY
  doSTORE bbc_a
  doCycles 6
@ -------------------------------------
_94:  @   STY $nn,X
  doZIX
  doSTORE bbc_y
  doCycles 4
@ -------------------------------------
_95:  @   STA $nn,X
  doZIX
  doSTORE bbc_a
  doCycles 4
@ -------------------------------------
_96:  @   STX $nn,Y
  doZIY
  doSTORE bbc_x
  doCycles 4
@ -------------------------------------
.type _98,function
_98:  @   TYA
  mov bbc_a,bbc_y
  mov bbc_nz,bbc_y,asr#24
  doCycles 2
@ -------------------------------------
_99:  @   STA $nnnn,Y
  doAIY
  doSTORE bbc_a
  doCycles 5
@ -------------------------------------
_9A:  @   TXS
  mov r0,bbc_x,lsr#24
  strb r0,bbc_stack           @don't make it harder than it is, use byte transfer!
  doCycles 2
@ -------------------------------------
_9D:  @   STA $nnnn,X
  doAIX
  doSTORE bbc_a
  doCycles 5
@ -------------------------------------
_A0:  @   LDY #$nn
  doIMM
  doLOAD bbc_y
  doCycles 2
@ -------------------------------------
_A1:  @   LDA ($nn,X)
  doIIX
  doLOAD bbc_a
  doCycles 6
@ -------------------------------------
_A2:  @   LDX #$nn
  doIMM
  doLOAD bbc_x
  doCycles 2
@ -------------------------------------
_A4:  @   LDY $nn
  doZ
  doLOAD bbc_y
  doCycles 3
@ -------------------------------------
_A5:  @   LDA $nn
  doZ
  doLOAD bbc_a
  doCycles 3
@ -------------------------------------
_A6:  @   LDX $nn
  doZ
  doLOAD bbc_x
  doCycles 3
@ -------------------------------------
_A8:  @   TAY
  mov bbc_y,bbc_a
  mov bbc_nz,bbc_y,asr#24
  doCycles 2
@ -------------------------------------
.type _A9,function
_A9:  @   LDA #$nn
  doIMM
  doLOAD bbc_a
  doCycles 2
@ -------------------------------------
_AA:  @   TAX
  mov bbc_x,bbc_a
  mov bbc_nz,bbc_x,asr#24
  doCycles 2
@ -------------------------------------
_AC:  @   LDY $nnnn
  doABS
  doLOAD bbc_y
  doCycles 4
@ -------------------------------------
.type _AD,function
_AD:  @   LDA $nnnn
  doABS
  doLOAD bbc_a
@  cmp bbc_nz,#1
@  beq testy
@.type nasty,function
@nasty:
@  cmp bbc_nz,#2
@testy:  
  doCycles 4
@ -------------------------------------
_AE:  @   LDX $nnnn
  doABS
  doLOAD bbc_x
  doCycles 4
@ -------------------------------------
_B0x: @   BCS
  orr bbc_cycles,bbc_cycles,#BRANCH
_B0:
  tst bbc_c,#PSR_C
  ldrsb r0,[bbc_pc],#1
  addne bbc_pc,bbc_pc,r0
  subne bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2
@ -------------------------------------
_B1:  @   LDA ($nn),Y
  doIIY
  doLOAD bbc_a
  doCycles 5
.pool
@ -------------------------------------
_B4:  @   LDY $nn,X
  doZIX
  doLOAD bbc_y
  doCycles 4
@ -------------------------------------
_B5:  @   LDA $nn,X
  doZIX
  doLOAD bbc_a
  doCycles 4
@ -------------------------------------
_B6:  @   LDX $nn,Y
  doZIY
  doLOAD bbc_x
  doCycles 4
@ -------------------------------------
_B8:  @   CLV
  mov r0,#0
  str r0,bbc_v
  doCycles 2

@ -------------------------------------
_B9:  @   LDA $nnnn,Y
  doAIY
  doLOAD bbc_a
  doCycles 4
@ -------------------------------------
_BA:  @   TSX
  ldrb bbc_x,bbc_stack
  mov bbc_x,bbc_x,lsl#24
  mov bbc_nz,bbc_x,asr#24
  doCycles 2
@ -------------------------------------
_BC:  @   LDY $nnnn,X
  doAIX
  doLOAD bbc_y
  doCycles 4
@ -------------------------------------
_BD:  @   LDA $nnnn,X
  doAIX
  doLOAD bbc_a
  doCycles 4
@ -------------------------------------
_BE:  @   LDX $nnnn,Y
  doAIY
  doLOAD bbc_x
  doCycles 4
.pool
@ -------------------------------------
_C0:  @   CPY #$nn
  doIMM
  doCOMP bbc_y
  doCycles 2
@ -------------------------------------
_C1:  @   CMP ($nn,X)
  doIIX
  doCOMP bbc_a
  doCycles 6
@ -------------------------------------
_C4:  @   CPY $nn
  doZ
  doCOMP bbc_y
  doCycles 3
@ -------------------------------------
_C5:  @   CMP $nn
  doZ
  doCOMP bbc_a
  doCycles 3
@ -------------------------------------
_C6:  @   DEC $nn
  doZ
  doDEC
  doCycles 5
@ -------------------------------------
_C8:  @   INY
  add bbc_y,bbc_y,#0x01000000
  mov bbc_nz,bbc_y,asr#24
  doCycles 2
@ -------------------------------------
_C9:  @   CMP #$nn
  doIMM
  doCOMP bbc_a
  doCycles 2
@ -------------------------------------
.type _CA,function
_CA:  @   DEX
  sub bbc_x,bbc_x,#0x01000000
  mov bbc_nz,bbc_x,asr#24
  doCycles 2
@ -------------------------------------
_CC:  @   CPY $nnnn
@ -------------------------------------
  doABS
  doCOMP bbc_y
  doCycles 4
@ -------------------------------------
_CD:  @   CMP $nnnn
@ -------------------------------------
  doABS
  doCOMP bbc_a
  doCycles 4
@ -------------------------------------
_CE:  @   DEC $nnnn
@ -------------------------------------
  doABS
  doDEC
  doCycles 6
@ -------------------------------------
_D0x:@   BNE
@ -------------------------------------
  orr bbc_cycles,bbc_cycles,#BRANCH
_D0:
  tst bbc_nz,#0xff
  ldrsb r0,[bbc_pc],#1
  addne bbc_pc,bbc_pc,r0
  subne bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2
@ -------------------------------------
_D1:  @   CMP ($nn),Y
@ -------------------------------------
  doIIY
  doCOMP bbc_a
  doCycles 5
@ -------------------------------------
_D5:  @   CMP $nn,X
@ -------------------------------------
  doZIX
  doCOMP bbc_a
  doCycles 4
@ -------------------------------------
_D6:  @   DEC $nn,X
@ -------------------------------------
  doZIX
  doDEC
  doCycles 6
@ -------------------------------------
_D8:  @   CLD
@ -------------------------------------
  ldr r0,bbc_di
  bic r0,r0,#D
  str r0,bbc_di
  doCycles 2
@ -------------------------------------
_D9:  @   CMP $nnnn,Y
@ -------------------------------------
  doAIY
  doCOMP bbc_a
  doCycles 4
@ -------------------------------------
_DD:  @   CMP $nnnn,X
@ -------------------------------------
  doAIX
  doCOMP bbc_a
  doCycles 4
@ -------------------------------------
_DE:  @   DEC $nnnn,X
@ -------------------------------------
  doAIX
  doDEC
  doCycles 7
@ -------------------------------------
_E0:  @   CPX #$nn
@ -------------------------------------
  doIMM
  doCOMP bbc_x
  doCycles 2
@ -------------------------------------
_E1:  @   SBC ($nn,X)
@ -------------------------------------
  doIIX
@  doSBC
@  doCycles 6
  doCompleteSBC 6
@ -------------------------------------
_E4:  @   CPX $nn
@ -------------------------------------
  doZ
  doCOMP bbc_x
  doCycles 3
@ -------------------------------------
_E5:  @   SBC $nn
@ -------------------------------------
  doZ
@  doSBC
@  doCycles 3
  doCompleteSBC 3
@ -------------------------------------
_E6:  @   INC $nn
@ -------------------------------------
  doZ
  doINC
  doCycles 5
@ -------------------------------------
.type _E8,function
_E8:  @   INX
  add bbc_x,bbc_x,#0x01000000
  mov bbc_nz,bbc_x,asr#24
  doCycles 2
@ -------------------------------------
_E9:  @   SBC #$nn
@ -------------------------------------
  doIMM
@  doSBC
@  doCycles 2
  doCompleteSBC 2
@ -------------------------------------
_EA:  @   NOP
@ -------------------------------------
  doCycles 2
@ -------------------------------------
_EC:  @   CPX $nnnn
@ -------------------------------------
  doABS
  doCOMP bbc_x
  doCycles 4
@ -------------------------------------
_ED:  @   SBC $nnnn
@ -------------------------------------
  doABS
@  doSBC
@  doCycles 4
  doCompleteSBC 4
@ -------------------------------------
_EE:  @   INC $nnnn
@ -------------------------------------
  doABS
  doINC
  doCycles 6
@ -------------------------------------
_F0x: @   BEQ
@ -------------------------------------
  orr bbc_cycles,bbc_cycles,#BRANCH
_F0:
  tst bbc_nz,#0xff
@ bne nobranch
  ldrsb r0,[bbc_pc],#1
  addeq bbc_pc,bbc_pc,r0
  subeq bbc_cycles,bbc_cycles,#1  @#3*CYCLE
  doCycles 2

@ -------------------------------------
_F1:  @   SBC ($nn),Y
@ -------------------------------------
  doIIY
@  doSBC
@  doCycles 5
  doCompleteSBC 5
@ -------------------------------------
_F5:  @   SBC $nn,X
@ -------------------------------------
  doZIX
@  doSBC
@  doCycles 4
  doCompleteSBC 4
@ -------------------------------------
_F6:  @   INC $nn,X
@ -------------------------------------
  doZIX
  doINC
  doCycles 6
@ -------------------------------------
_F8:  @   SED
@ -------------------------------------
  ldr r0,bbc_di
  orr r0,r0,#D
  str r0,bbc_di
  doCycles 2
@ -------------------------------------
_F9:  @   SBC $nnnn,Y
@ -------------------------------------
  doAIY
@  doSBC
@  doCycles 4
  doCompleteSBC 4
@ -------------------------------------
_FD:  @   SBC $nnnn,X
@ -------------------------------------
  doAIX
@  doSBC
@  doCycles 4
  doCompleteSBC 4
@ -------------------------------------
_FE:@   INC $nnnn,X
@ -------------------------------------
  doAIX
  doINC
  doCycles 7

.type _00,function
_00: @BRK
  
  sub r0,bbc_pc,bbc_mem          @r0 = pc - mem addr
  add r0,r0,#1
  push16			@save PC

	encodeP (B)		@save P
	push8 r0

	ldr r1,bbc_di
	orr r1,r1,#I		@disable IRQ
	str r1,bbc_di

	mov r0,r11 
@	ldr r0,[r0]       @wholeram
	ldr r1,=BRK_VECTOR
	ldrb bbc_pc,[r0,r1]!
	ldrb r2,[r0,#1]
	orr bbc_pc,bbc_pc,r2,lsl#8
        encodePC 
	doCycles 7


.pool


  .align	2
	.global run_emu
	.type	run_emu,function
run_emu:
  ldr r1,=Asm6502State
  ldr bbc_pc,[r1,#0]
  ldr r0,=WholeRam     @ address of WholeRam stored in here...
  ldr bbc_mem,[r0]
  add bbc_pc,bbc_pc,bbc_mem
  ldrb bbc_a,[r1,#4]
  mov bbc_a,bbc_a,lsl#24
  ldrb bbc_x,[r1,#8]
  mov bbc_x,bbc_x,lsl#24
  ldrb bbc_y,[r1,#12]
  mov bbc_y,bbc_y,lsl#24
  mov bbc_cycles,#0
  ldr   r0,=timerDecrement
  str bbc_cycles,[r0]
  adr bbc_optbl,op_table
  ldrb r0,[r1,#16]     @ r0 = PSR
  decodeP             @places flags in bbc_nz, bbc_di, bbc_v, bbc_c
  @ set up next event...
@  mov     r0, #0
@  ldr     r1, intStatus
@  str     r0, [r1]            @  int status
@  cmp     r0, #0
@  ldr     r2, 1f              @videoStartOfFrame
@  beq   2f                    @ no interrupt
@  @ else test I val
@  ldr     r1,bbc_di
@  tst     r1,#I                   @ is I set?
@  ldreq   r0,=doInterrupt         @ Equals = Zero = bit not set
@  ldrne   r0,=endScanline         @ Equals = Zero = bit not set
@2:
  
  ldr     r2, 1f          @videoStartOfFrame
  str     r2,nextEvent
  ldr     pc,=endScanline


#ifdef DEBUG
@debugging code  - dumps the cpu state...

.type debugOutput,function
debugOutput:
  
  encodeP (R)
  ldr r1,=Asm6502State 
       
  str r0,[r1,#16]       @psr
  str bbc_pc,[r1,#0]
  str bbc_a,[r1,#4]
  str bbc_x,[r1,#8]
  @str bbc_nz,[r1,#8]
  str bbc_y,[r1,#12]
  
  str r2,[r1,#24] @cyclesValue
  
  ldr r0,LdumpRegs
  stmfd   r13!,{r3-r11,lr}
  adr lr,endDebugging
.type jumpToC,function
jumpToC:
  bx  r0
.type endDebugging,function
endDebugging:
  ldmfd   r13!,{r3-r11,lr}
  mov pc,lr

.align 4
LdumpRegs:
.word dumpRegs

#endif

.global setupMenu
.type setupMenu,function
setupMenu:
  
  encodeP (B+R)
  ldr r1,=Asm6502State 
       
  str r0,[r1,#16]       @psr
  str bbc_pc,[r1,#0]
  str bbc_a,[r1,#4]
  str bbc_x,[r1,#8]
  @str bbc_nz,[r1,#8]
  str bbc_y,[r1,#12]
  
  str r2,[r1,#24] @cyclesValue
  
@  stmfd   r13!,{r3-r11,lr}
@  adr lr,endMenu
  ldr  sp,=__sp_usr
  ldr  r0,Lmenu
  bx   r0                @ branch with "interwork", menu is compiled thumb
@  ldr  pc,Lmenu
@endMenu:
@  ldmfd   r13!,{r3-r11,lr}
@  mov pc,lr

.align 4
Lmenu:
.word doMenu

@.global setupSave
@.type setupSave,function
@setupSave:
@  
@  encodeP (B+R)
@  ldr r1,=Asm6502State 
@       
@  str r0,[r1,#16]       @psr
@  str bbc_pc,[r1,#0]
@  str bbc_a,[r1,#4]
@  str bbc_x,[r1,#8]
@  @str bbc_nz,[r1,#8]
@  str bbc_y,[r1,#12]
@  
@  str r2,[r1,#24] @cyclesValue
@  
@  ldr r0,Lsave
@  stmfd   r13!,{r3-r11,lr}
@  adr lr,endSave
@  bx  r0
@.type endSave,function
@endSave:
@  ldmfd   r13!,{r3-r11,lr}
@  mov pc,lr
@
@.align 4
@Lsave:
@.word save
@
@
@.global setupLoad
@.type setupLoad,function
@setupLoad:
@  ldr     sp,=__sp_usr            @ Set SP_usr
@  ldr r0,Lload
@  bx  r0
@
@.align 4
@Lload:
@.word load


@ interrupt hack... might need checking more often? like every scanline?
.global doInterrupt     
.type doInterrupt, function
doInterrupt:
  sub r0,bbc_pc,bbc_mem          @r0 = pc - mem addr
  push16            @save PC
  encodeP (R)				@save P
  bic   r0,r0,#B       @ clear B
  push8 r0
  
@  ldr     r1, intStatus
  mov     r0, #0
  str     r0, intStatus  @[r1]            @  int status is already the value!
  
  ldr r1,bbc_di
  orr r1,r1,#I				@disable IRQ
  str r1,bbc_di
  @JMP irq
  ldr r1,0f         @WholeRam
  ldr r0,[r1]       @ address of malloc'd ram
  ldr r1,=IRQ_VECTOR  @fffe
  ldrb bbc_pc,[r0,r1]!    @bbc_pc = r0[r1]
  ldrb r2,[r0,#1]         @r2    = r0[r1+1]
  orr bbc_pc,bbc_pc,r2,lsl#8
  encodePC
  @ adujst cycles for interrupt delay...
@  sub bbc_cycles,bbc_cycles,#7 @#3*7*CYCLE
  @ldr r0,1f         @videoStartOfFrame
  @str r0,nextEvent
#ifdef DEBUG
  @ isInINT is now 1
  ldr   r0,LisInINT2
  mov   r1,#1
  str   r1,[r0]  
#endif
#ifdef DEBUG_DISC
  stmfd   sp!,{r3-memptr}
  adr lr,5f
  ldr r5,=dump_ir
  bx  r5
5:
  ldmfd   sp!,{r3-memptr}
#endif
  @doCycles 6
  doCycles 14

  ldr pc,=endScanline


@ NMI interrupt 
.global NMIinterrupt
.type NMIinterrupt, function
NMIinterrupt:
  sub r0,bbc_pc,bbc_mem          @r0 = pc - mem addr
  push16            @save PC
  encodeP (R)				@save P
  push8 r0
  
  @ldr     r1, intStatus
  @ldr     r1, [r1]            @  int status is already the value!
  
  ldr r1,bbc_di
  orr r1,r1,#I				@disable IRQ
  str r1,bbc_di
  @JMP irq
  ldr r1,0f         @WholeRam
  ldr r0,[r1]       @ address of malloc'd ram
  ldr r1,=NMI_VECTOR  @fffa
  ldrb bbc_pc,[r0,r1]!    @bbc_pc = r0[r1]
  ldrb r2,[r0,#1]         @r2    = r0[r1+1]
  orr bbc_pc,bbc_pc,r2,lsl#8
  encodePC
  @ adujst cycles for interrupt delay...
  @sub bbc_cycles,bbc_cycles,#7 @#3*7*CYCLE
  @ldr r0,1f         @videoStartOfFrame
  @str r0,nextEvent
  @ isInINT is now 1
#ifdef DEBUG
  ldr   r0,LisInINT2
  mov   r1,#2
  str   r1,[r0]  
#endif
@#ifdef DEBUG_DISC
@  stmfd   sp!,{r0-memptr,lr}
@  adr lr,endDebugDisc
@  ldr r5,=dump_nmi_ir
@  bx  r5
@endDebugDisc:
@  ldmfd   sp!,{r0-memptr,lr}
@#endif
  @ before doing anything, make sure we call the disc interrupt

#if 0  
  
  stmfd  sp!,{r0-r12}
  ldr   r1,=debugNMI
  adr   lr,returnFromDebug
  bx    r1
returnFromDebug:
  ldmfd  sp!,{r0-r12}
#endif

#if 0  
  ldr   r1,=disc_trigger
  ldr   r2,[r1]
  cmp   r2,#0
  beq   8f
@  ldr   r0,discDecrement
@  subs  r2,r2,r0
@  subs  r2,r2,#128
  mov   r2,#0
  str   r2,[r1]
@  bpl   8f
  @ if -ve, need to call function
  ldr    r1,=current_command
  ldr    r1,[r1]
  ldr    r2,[r1,#16]  @ the intfunc
  cmp    r2,#0
  adrne   lr,8f
  bxne    r2
8:
#endif
  doCycles 6

  ldr pc,=endScanline


#ifdef DEBUG
LisInINT2:
.word isInINT
#endif

.global op_table
op_table:
  .word _00,_01,_xx,_xx,_xx,_05,_06,_xx,_08,_09,_0A,_xx,_xx,_0D,_0E,_xx
  .word _10,_11,_xx,_xx,_xx,_15,_16,_xx,_18,_19,_xx,_xx,_xx,_1D,_1E,_xx
  .word _20,_21,_xx,_xx,_24,_25,_26,_xx,_28,_29,_2A,_xx,_2C,_2D,_2E,_xx
  .word _30,_31,_xx,_xx,_xx,_35,_36,_xx,_38,_39,_xx,_xx,_xx,_3D,_3E,_xx
  .word _40,_41,_xx,_xx,_xx,_45,_46,_xx,_48,_49,_4A,_xx,_4C,_4D,_4E,_xx
  .word _50,_51,_xx,_xx,_xx,_55,_56,_xx,_58,_59,_xx,_xx,_xx,_5D,_5E,_xx
  .word _60,_61,_xx,_xx,_xx,_65,_66,_xx,_68,_69,_6A,_xx,_6C,_6D,_6E,_xx
  .word _70,_71,_xx,_xx,_xx,_75,_76,_xx,_78,_79,_xx,_xx,_xx,_7D,_7E,_xx
  .word _xx,_81,_xx,_xx,_84,_85,_86,_xx,_88,_xx,_8A,_xx,_8C,_8D,_8E,_xx
  .word _90,_91,_xx,_xx,_94,_95,_96,_xx,_98,_99,_9A,_xx,_xx,_9D,_xx,_xx
  .word _A0,_A1,_A2,_xx,_A4,_A5,_A6,_xx,_A8,_A9,_AA,_xx,_AC,_AD,_AE,_xx
  .word _B0,_B1,_xx,_xx,_B4,_B5,_B6,_xx,_B8,_B9,_BA,_xx,_BC,_BD,_BE,_xx
  .word _C0,_C1,_xx,_xx,_C4,_C5,_C6,_xx,_C8,_C9,_CA,_xx,_CC,_CD,_CE,_xx
  .word _D0,_D1,_xx,_xx,_xx,_D5,_D6,_xx,_D8,_D9,_xx,_xx,_xx,_DD,_DE,_xx
  .word _E0,_E1,_xx,_xx,_E4,_E5,_E6,_xx,_E8,_E9,_EA,_xx,_EC,_ED,_EE,_xx
  .word _F0,_F1,_xx,_xx,_xx,_F5,_F6,_xx,_F8,_F9,_xx,_xx,_xx,_FD,_FE,_xx
  
  .global stack
  stack:      .space 4
  .global the_di
  the_di:         .space 4
  the_v:          .space 4
  .global nextEvent
  nextEvent:      .space 4
  .global intStatus
  intStatus:      .space 4
  
@ read memory table   feX0, where X is:
readmem_tbl:
  .word AsmCRTCRead       @0
  .word unknownRead       @1
  .word unknownRead       @2    ?? 1770 on Master
  .word pagedRomRead      @3    return current rom paged
  .word sysVIARead        @4
  .word sysVIARead        @5
  .word userVIARead       @6
  .word userVIARead       @7
#if USE_1770_DISC
  .word disc1770Read      @8    
  .word unknownRead      @9
#else
  .word disc8271Read      @8    
  .word disc8271Read      @9
#endif
  .word econetRead        @a  
  .word unknownRead       @b
  .word analogRead        @c    
  .word unknownRead       @d
  .word tubeRead          @e
  .word unknownRead       @f

@ write memory table   feX0, where X is:
writemem_tbl:
  .word AsmCRTCWrite      @0
  .word unknownWrite      @1
  .word videoULAWrite     @2    
  .word romChangeWrite    @3    swaps 16k rom roms out of top bank of mem
  .word sysVIAWrite       @4
  .word sysVIAWrite       @5
  .word userVIAWrite      @6
  .word userVIAWrite      @7
#if USE_1770_DISC
  .word disc1770Write     @8
  .word unknownWrite      @9
#else
  .word disc8271Write     @8
  .word disc8271Write     @9
#endif
  .word unknownWrite      @a  
  .word unknownWrite      @b
  .word unknownWrite      @c    
  .word unknownWrite      @d
  .word unknownWrite      @e    
  .word unknownWrite      @f

.global Asm6502State
Asm6502State:     .space 24
@  programCounter: .space 4
@  accumulator:    .space 4
@  XReg:           .space 4
@  YReg:           .space 4
@  PSR:            .space 4

.global cyclesValue
cyclesValue: .space 4

0:
.word WholeRam
1:
.word videoStartOfFrame
.word videoDoScanLine


.pool
