
@ 8271 disc emulation in arm
.section .iwram,"ax",%progbits
.arm

#define    rstat    r2
#define    rsecl    r3

.macro  updateNMI
    @ r1 holds new status
    ldr    r4,=NMIintStatus
    ldr    r5,[r4]
    tsts   r1,#8
    biceq  r5,r5,#(8|16)
    orrne  r5,r5,#(8)
    str    r5,[r4]
.endm

.global initial_byte
initial_byte: .space 4
.global final_byte
final_byte: .space 4
#if 1
.global readint
.type readint,function
readint:
   @ read interupts occur all the time!
   @ called every other vblank when things are loading
   @ all registers are free to use...
   ldr       rstat,=status
   ldr       rsecl,=sectors_left
   ldr       r1,[rsecl]
   cmp       r1,#0
   bmi       noSectorsLeft          @ "rare" case, so branch
   @ else we have sectors left
   @ status = 0x8c;
   mov       r1,#0x8c
   @ bytes_read++;  ??
   ldr     r4,=discs   @ address of pointer to disc
   ldr     r4,[r4]     @ address of data disc
   cmp     r4,#0
   beq     noSectorsLeft
   ldr     r5,initial_byte     @ == (current_sector + current_track*10)*256 + byte
   ldr     r6,=datareg
   ldrb    r4,[r4,r5]
   str     r4,[r6]
   @ datareg = discs[ (current_sector+current_track*10)*256 + bytes_in_sector];
   add     r5,r5,#1 
   ldr     r4,final_byte    
   cmp     r5,r4
   @ have we reached the end?
   bpl     nextSector       @ every 256 bytes, increase the sector
   @ else we are in the same sector
   @ bytes_in_sector++;
   @ result = 0;
   str     r5,initial_byte
finishOff:
   ldr     r5,=result
   mov     r4,#0
   str     r4,[r5]    @ result = 0
   str     r1,[rstat] @ status = 0x8c
   updateNMI
   ldr     r5,=disc_trigger
   mov     r4,#160
   str     r4,[r5]
   @disc_trigger = DISC_CYCLES;
   mov     pc,lr
  
nextSector: 
    @ if (bytes_in_sector >= sector_len) {

    @  bytes_in_sector = 0;
    ldr      r7,[rsecl]
    subs     r7,r7,#1
    @ if eq (sectors left == 0)...
    moveq   r1,#0x9c      @status = 0x9c
    subeq   r7,r7,#1
    str     r7,[rsecl]       @ store sectors left
    beq     finishOff
    @  if (--sectors_left) {
    @ have sectors left to read
    ldr      r6,=current_sector
    ldr      r7,[r6]
    add      r7,r7,#1
    cmp      r7,#10
    bpl      sectorOverflow      @ if we reach sector 10, jump
    @ mov      r1,#0x9c            
    @else
    str      r7,[r6]
    @  need to calculate the new offset into the disc
    @  this is (current_sector+current_track*10)*256 (+0)
    @ and the final byte is that + sector_len
    ldr      r8,=current_track
    ldr      r8,[r8]
    mov      r5,#0xa00
    mul      r6,r8,r5      @ track * 10 * 256
    add      r8,r6,r7,lsl #8   @ track * 10 * 256 + sector * 256
    str      r8,initial_byte
    ldr      r5,=sector_len
    ldr      r5,[r5]
    add      r8,r8,r5     @ increase by sector length
    str      r8,final_byte
    b        finishOff

sectorOverflow: 
    @ if (++current_sector == 10) {
    mov      r7,#0
    str      r7,[r6]    @
    @ current_sector = 0;
    @ sectors_left = -1;
    mov      r7,#-1
    str      r7,[rsecl]    @
    mov      r1,#0x9c
    @ status = 0x9c;
    b        finishOff

noSectorsLeft:
   @ if (sectors_left < 0) {
   @   status = 0x18;
   stmfd sp!,{r1-r12,lr}
   mov   r0,#19
   adr   lr,0f
   ldr   r1,=clearTextRow
   bx    r1
0:
   ldmfd sp!,{r1-r12,lr}
   mov     r1,#0x18
   str     r1,[rstat]
   updateNMI
   @   return;
   mov     pc,lr
#endif
.pool

.end

