#include "fastvideo.h"
#include "gamemenu.h"
#include "menu.h"
#include "gfx.h"

#define ID_KEY  11

// hacky way to do this...
// type is a mask   
unsigned int setHeaderTo(int wanted, int type) {
  gameheader_t * header;
  unsigned long nextHeaderPtr;
  
  // get the address of the first header:
  unsigned long * total = (unsigned long*) (endOfGBA-4);
  unsigned long gameCount = ((*total)&0xffff) + (( (*total)>>16)&0xffff );
#if 0
  gbaprintf("total %d\n",gameCount);
  gbaprintf("endOfGBA %x\n",endOfGBA);
#endif
  
  unsigned long splash = * (unsigned long*) (endOfGBA-8);
  if (0 != (splash &3)) {
    splash += 4 - (splash&3);
  }

  header = (gameheader_t *)((unsigned long) (endOfGBA+splash) );
  nextHeaderPtr = (unsigned int)header + sizeof(gameheader_t) + header->size;
  int headertype = header->keyCodes[ID_KEY]; 
  int index = -1;
  int read = 1;
  if ((nextHeaderPtr&3))
    nextHeaderPtr += (4-(nextHeaderPtr&3));
  while (index < wanted && read <= gameCount) {
    if (headertype & type) {
      index++;
      if (index == wanted)
        break;
    } 
    header = (gameheader_t *)nextHeaderPtr;
    nextHeaderPtr = nextHeaderPtr + sizeof(gameheader_t) + header->size;
    if ((nextHeaderPtr&3))
      nextHeaderPtr += (4-(nextHeaderPtr&3));
    read++;
    headertype = header->keyCodes[ID_KEY]; 
  }
  if (read > gameCount)
    header = 0;
  return (unsigned int)header;
}

void getGameToLoad(unsigned int * start, unsigned int * end, int wanted, int type) {
  int i;
  extern char mappedKeys[10];
  unsigned long headerAdr = setHeaderTo(wanted,type);
  gameheader_t * header = (gameheader_t *)headerAdr;
  
  // most likely broken
  if (header == 0 || header->size > 0x100000 || header->size == 0) {
    *end = 0;
    return;
  }
  
  *start = headerAdr+sizeof(gameheader_t);
  *end = *start + header->size;
  
  for (i = 0; i < 10; i++) 
    mappedKeys[i] = header->keyCodes[i];

  if (header->xScale == 0) {
    // auto scale
    CRTCControl.CRTC_VerticalDisplayed = header->yScale;
    autoScale();
  } else {
    setSpriteScreen(header->xScale,header->yScale);
  }
}


int getGameCount(int type) {
  unsigned long * total = (unsigned long*)(endOfGBA-4);
  int totalUEF = (*total)&0xffff;
  int totalSSD = ((*total)>>16)&0xffff;
  if (type == IS_SSD)
    return totalSSD;
  if (type == IS_UEF)
    return totalUEF;
  return 0;
/*  gameheader_t * header;
  int available = 0;  
  int index = 0;  
  header = (gameheader_t *)setHeaderTo(index,IS_UEF|IS_SSD);
  while (header->size) {
    if (header->keyCodes[ID_KEY] == type) {
      ++available;
    }
    header = (gameheader_t *)setHeaderTo(++index,IS_UEF|IS_SSD);
  }
  return available;
  */
}

void createGameList(int startIndex, int type) {
  // skip startIndex headers and then display til the end, or MAX_GAMES_SHOWN headers
  gameheader_t * header;
  header = (gameheader_t *)setHeaderTo(startIndex++,type);
  int vid = 0;
  while (header!=0 && vid<MAX_GAMES_SHOWN) {
    printTxt(header->name, 2,MENU_Y_OFFSET+vid); 
    vid++;
    header = (gameheader_t *)setHeaderTo(startIndex++,type);
    
  }
  
}
  
