
#ifndef _gamemenu_h
#define _gamemenu_h

/*
  Size: 4 byte size
  userName : 12 bytes for the name, username[11] == 0
  keys[]  : 12 bytes 10 for the key maps, 2 spare
  x       : 2 bytes for x scale value
  y       : 2 bytes for y scale value
  dx      : 2 bytes for x offset
  dy      : 2 bytes for y offset
  
  total size 36 bytes  
*/

// don't want this padded really
typedef struct { 
  unsigned int size;
  unsigned char name[12];
  unsigned char keyCodes[12];
  unsigned short xScale;
  unsigned short yScale;
  unsigned short xOff;
  unsigned short yOff;
} gameheader_t;

#define endOfGBA (0x8000000 + PADDED_SIZE)

#define IS_SSD 1
#define IS_UEF 2
#define MAX_GAMES_SHOWN 10

void getFirstGameToLoad(unsigned int * start, unsigned int * end);
void getGameToLoad(unsigned int * start, unsigned int * end, int wanted,int type);
void createGameList(int startIndex, int type);
int getGameCount(int);

#endif
