/*
* $Log: gfx.h,v $
* Revision 1.4  2004/10/02 16:21:58  richq
* Version 1 additions/changes
*
* Revision 1.3  2004/08/08 20:02:40  richq
* First working version
*
* Revision 1.2  2004/05/02 15:32:31  richq
* Decent working version of the emulator. Handles just mode 2,
* but includes multi game selection and key configuration menus.
*
* Revision 1.1.1.1  2004/04/24 14:59:45  richq
* PocketBeeb - BBC emulator for the GBA
*
*/
#ifndef GFX_H
#define GFX_H

#include "backgrounds.h"
#include "gba.h"
#include "sprite.h"




extern Bg bg_teletextfg;
extern Bg bg_teletextbg;
extern Bg bg_menu;


void initBackground(Bg * bg, int number,
                    int charBlock, int screenBlock, 
                    int priority);
void clear_vram(void);

void move_sprite(int id, int x, int y);
//void ScaleSprite(u16 rotDataIndex, FIXED x_scale,FIXED y_scale);
void MoveSprite(OAMEntry* sp, int x, int y);
void CopyOAM(void);

void remove_sprite(int id);

void fade_up(void);
void fade_down(void);

void initColour(void) ;
void initBG(void);
void printTxt(const char * const text, int row, int col);
void printTxtPal(char * text, int row, int col,int pal);
void print_text(char text, int x, int y, int pal);
void print_teletext(int x, int y, int pal, char text);
void print_teletextbg(int x, int y, int pal);
void setRowPalette(int row, int newPalette);
void clearText(void);
void clearTextRow(int row);

void setSpriteScreen(int scale_x, int scale_y);
void setSpriteScreenHalfWidth(int scale_x,int scale_y);
void autoScale(void);
void adjustOffset(int dx, int dy);
void updateColours(void);
void get_pal_indices(unsigned char * p);
#if defined(ELITE_HACK)
#define COPY_COLOURS 16
void setEliteScanner(void);
#else
#define COPY_COLOURS 16
#endif


#endif

