#ifndef _menudata_h
#define _menudata_h

#define INCLUDE_DEBUG 0

typedef void (*FunctionPtr)(void);

typedef struct
{
    char * cName; // text value of the option on screen
    char * cTip; // "tool tip" style helpful hint
    unsigned short nMin;     // min value
    unsigned short nMax;     // max value
} option_t;

typedef struct
{
    char * cName; // text value of the menu on screen
    char * cTip; // "tool tip" style helpful hint
    FunctionPtr createMenu; // routine to call to set up the menu
    
} menu_t;
#if INCLUDE_DEBUG
#define MENU_CNT 7
#else
#define MENU_CNT 6
#endif
extern const menu_t g_theMenus[MENU_CNT];
extern const option_t g_keyOptions[];
extern const option_t g_videoOptions[];
extern const option_t g_resetOptions[];
extern const option_t g_sramOptions[];
extern const option_t g_notDoneOption[];
extern const option_t * const g_optionTable[];
extern const unsigned char g_optionCount[];


#endif //_menudata_h
