
#ifndef videomacros_h_seen
#define videomacros_h_seen

.macro updateTimers
@ update the timers
  adr   lr,9f
  ldr   pc,=doViaPolls @ VIAPolls
9:
.endm
.macro  updateDisc
  ldr   r1,=disc_trigger
  ldr   r2,[r1]
  cmp   r2,#0
  beq   8f
  subs  r2,r2,#128
  movmi r2,#0
  str   r2,[r1]
  bpl   8f
  @ if -ve, need to call function
  ldr    r1,=current_command
  ldr    r1,[r1]
  ldr    r2,[r1,#16]  @ the intfunc
  cmp    r2,#0
  adrne   lr,8f
  bxne    r2
8:
.endm

@ copy the vide state in here
@AsmVideoState:  
@  .word VideoState    @<- pointer to videostate
@ the offsets to the various parts of the ULA video state
.equ OFFSET_Addr,                     0   @Address of start of next visible character line in beeb memory  
@.equ OFFSET_PixmapLine,               4   @Current line in the pixmap 
.equ OFFSET_PreviousFinalPixmapLine,  8   @The last pixmap line on the previous frame 
.equ OFFSET_IsTeletext,               12  @This frame is a teletext frame - do things differently 
.equ OFFSET_DataPtr,                  16  @Pointer into host memory of video data
.equ OFFSET_CharLine,                 20  @6845 counts in characters vertically - 0 at the top , incs by 1 
                                          @ -1 means we are in the bit before the actual display starts
.equ OFFSET_InCharLine,               24  @Scanline within a character line - counts down
.equ OFFSET_InCharLineUp,          28 @   32  @Scanline within a character line - counts up
.equ OFFSET_VSyncState,            32 @   36  @When >0 VSync is high

@VideoStateT


.equ  OFFSET_ControlReg           , (0*4)
.equ  OFFSET_HorizontalTotal      , (1*4)
.equ  OFFSET_HorizontalDisplayed  , (2*4)
.equ  OFFSET_HorizontalSyncPos    , (3*4)
.equ  OFFSET_SyncWidth            , (4*4)
.equ  OFFSET_VerticalTotal        , (5*4)
.equ  OFFSET_VerticalTotalAdjust  , (6*4)
.equ  OFFSET_VerticalDisplayed    , (7*4)
.equ  OFFSET_VerticalSyncPos      , (8*4)
.equ  OFFSET_InterlaceAndDelay    , (9*4)
.equ  OFFSET_ScanLinesPerChar     , (10*4)
.equ  OFFSET_CursorStart          , (11*4)
.equ  OFFSET_CursorEnd            , (12*4)
.equ  OFFSET_ScreenStartHigh      , (13*4)
.equ  OFFSET_ScreenStartLow       , (14*4)
.equ  OFFSET_CursorPosHigh        , (15*4)
.equ  OFFSET_CursorPosLow         , (16*4)
.equ  OFFSET_LightPenHigh         , (17*4)
.equ  OFFSET_LightPenLow          , (18*4)

#endif

