
#include "agbprint.h"

#include "input.h"
#include "inputcodes.h"
#include "6502core.h"
#include "fastvideo.h"
#include "keypad.h"
//#include "windows.h"
#include "sysvia.h"


// state table - 1 on, 0 off
// how many keys are pressed at once
void releaseAllKeys(void){
  KeysDown = 0;
  int row, col;
  for(row=0;row<8;row++)
    for(col=0;col<10;col++)
      SysViaKbdState[col][row]=0;
}
#if defined(DEBUG)
void keyPressed(int row, int col){
  
  /* Update keys down count - unless its shift/control */
  if ((!SysViaKbdState[col][row]) && (row!=0)) KeysDown++;
  
  SysViaKbdState[col][row]=1;
  
  needKeyInterrupt = DO_INTERRUPT;
  
}
#endif
#if 0

// if 0, don't trigger interrupt
// checked each frame
int needKeyInterrupt = 0;
// press a keyboard key
void keyPressed(int row, int col){
  
  /* Update keys down count - unless its shift/control */
  if ((!SysViaKbdState[col][row]) && (row!=0)) KeysDown++;
  
  SysViaKbdState[col][row]=1;
  
  needKeyInterrupt = DO_INTERRUPT;
  
}
// release a keyboard key
void keyReleased(int row, int col){
  /* Update keys down count - unless its shift/control */
  if ((SysViaKbdState[col][row]) && (row!=0)) KeysDown--;
  
  SysViaKbdState[col][row]=0;
}

int  returnbreaker() {
  int i = 1;
  return i*2;
}
// an event occurs
void keyEvent(int eventtype, unsigned int key){
  
  
  signed char col = GET_TABLE_VAL(key, KEY_COL);
  signed char row = GET_TABLE_VAL(key, KEY_ROW);
  
  if (col >=0) {
    if (eventtype == KEYDOWN) {
      if ((!SysViaKbdState[col][row]) && (row!=0)) {
        KeysDown++;
      }
      needKeyInterrupt = DO_INTERRUPT;
      SysViaKbdState[col][row]=1;
    } 
    else if (eventtype == KEYUP) {
      if ((SysViaKbdState[col][row]) && (row!=0)) {
        KeysDown--;
      }
      SysViaKbdState[col][row]=0;
      
    }
  }
}
const int keyCodes[10] = {

  KEY_A,
  KEY_B,
  
  KEY_UP,
  KEY_DOWN,
  KEY_LEFT,
  KEY_RIGHT,
  
  KEY_R,
  KEY_L,
  KEY_START,
  KEY_SELECT,
};
#endif

#if 1
unsigned char mappedKeys[10] = {
  
  0xc,    // KEY_A,    
  '.',    // KEY_B,    
  ' ',    // KEY_SELECT
  0xd,    // KEY_START,
  
  'Z',    // KEY_RIGHT,
  'X',    // KEY_LEFT, 
  ':',    // KEY_UP,   
  '/',    // KEY_DOWN, 
  
  0x4,    // KEY_R,    
  0x3,    // KEY_L,    
  
};
#else
unsigned char mappedKeys[10] = {
  
  0,    // KEY_A,    
  0,    // KEY_B,    
  0,    // KEY_SELECT
  0,    // KEY_START,
  
  0,    // KEY_RIGHT,
  0,    // KEY_LEFT, 
  0,    // KEY_UP,   
  0,    // KEY_DOWN, 
  
  0,    // KEY_R,    
  0,    // KEY_L,    
  
};
#endif


#if 0
#define isPressed(key)    ( (pressed&key)==key && (lastKeys&key) )
//#define isPressed(key)    ( (pressed&key)==key  )
#define isReleased(key)   ( (released&key) == key )

void handleKeys(void) {
  // which ones have been released since last time
  extern unsigned int thisKeys;
  extern unsigned int lastKeys;
  int i;
  unsigned int released = ((thisKeys^lastKeys)&thisKeys);
  unsigned int pressed = (~thisKeys);
  if (thisKeys == lastKeys)
    return;
  for (i = 0; i < 10; i++) {
    if (isPressed(keyCodes[i])) {
      keyEvent(KEYDOWN, mappedKeys[i]);
    }
    if (isReleased(keyCodes[i])) {
      keyEvent(KEYUP, mappedKeys[i]);
    }
  }
  
  if ((pressed&(KEY_START|KEY_SELECT))==((KEY_START|KEY_SELECT)) && (lastKeys&(KEY_START|KEY_SELECT))) {
    REG_IME = 0; // switch off ints
    releaseAllKeys();
    needKeyInterrupt = GO_MENU;
  }
  
}

void dumpKeyPress(void) {
  gbaprintf("ki %d kd %d \n",needKeyInterrupt, KeysDown );
}
#endif
