
#include "gba.h"
#include "dma.h"
#include "keypad.h"

#include "input.h"
#include "inter.h"
#include "interrupts.h"
#include "virtualkb.h"
#include "gfx.h"
#include "sysvia.h"

/*IN_IWRAM 
void VBlankInterruptHandler(void) {

  UpdateKeys();
  handleKeys();
//  updateColours();
  
  // let the bios know that vblank occurred
  (*(volatile u32*)0x03fffff8) |= INT_VBLANK;
  REG_IF |= INT_VBLANK;
  
}
*/
// this code is called every frame while on the menu
void MenuInterruptHandler(void) {

  UpdateKeys();
  
  // let the bios know that vblank occurred
  (*(volatile u32*)0x03fffff8) |= INT_VBLANK;
  REG_IF |= INT_VBLANK;
  
}
void resetBeeb(int );
#define isPressed(key)    ( (pressed&key)==key && (lastKeys&key) )
#define isReleased(key)   ( (released&key) == key )
void VKInterruptHandler(void) {

  UpdateKeys();
  
  // let the bios know that vblank occurred
  (*(volatile u32*)0x03fffff8) |= INT_VBLANK;
  REG_IF |= INT_VBLANK;
  
  if (KeyPressedNoBounce(KEY_UP,5))
    vk_up(); 
  if (KeyPressedNoBounce(KEY_DOWN,5))
    vk_down(); 
  if (KeyPressedNoBounce(KEY_RIGHT,5))
    vk_right(); 
  if (KeyPressedNoBounce(KEY_LEFT,5))
    vk_left(); 

  if (apply_vk_press) {
    // make the key press "work" for us...
    //extern unsigned int thisKeys;
    //extern unsigned int lastKeys;
    unsigned int released = ((thisKeys^lastKeys)&thisKeys);
    unsigned int pressed = (~thisKeys);
    if (thisKeys == lastKeys)
      return;

    int row, col, key;
    get_vk_selected(&row, &col, &key);

    if (isPressed(KEY_A)) {
      if ((!SysViaKbdState[col][row]) && (row!=0)) {
	KeysDown++;
      }
      needKeyInterrupt = DO_INTERRUPT;
      SysViaKbdState[col][row]=1;
    }
    if (isReleased(KEY_A)) {
      if ((SysViaKbdState[col][row]) && (row!=0)) {
        KeysDown--;
      }
      SysViaKbdState[col][row]=0;
    }
    if (isPressed(KEY_R) ) {
      // rotate right
      move_vk(1);
    }
    if (isPressed(KEY_L) ) {
      // rotate left
      move_vk(-1);
    }
    if (isPressed(KEY_B) ) {
      apply_vk_press = 0;
      releaseAllKeys();
      clearText();
      lastKeys = thisKeys;
      REG_INTERUPT = (u32)irqarm;
    }
  }
}

