
#include "6502macros.h"

@ With this set to 1, some games look rubbish (e.g. Stryker's Run)
@ that is cos I don't emulate colours properly...
#define NO_BG_COLOUR 0
#define HW_COLOUR 0

@ Elite hack... attempt to get elite to work-ish

.section .iwram,"ax",%progbits
.align 4
.code 32
@ this contains memory writing

@ input r0 = value, r12 = memptr = address to write to
.global videoULAWrite
.extern colours
.extern VideoState
.extern scanlineFunction
.extern lowLevelDoScanLineNarrow
.extern lowLevelDoScanLineWide
.extern clearTeletext
.type videoULAWrite,function
videoULAWrite:
  tst   memptr,#1
  beq   evenVideULAWrite
  ands  r2,r0,#0xf0        @ that s means "let me know if the result is zero"
  and   r1,r0,#15
  eor   r1,r1,#7
  @ updates the gba sprite palette here
  ldr   r0,=colours           @ colour table
  ldr  r1,[r0,r1,lsl#2]      @ r1 is the new colour (15 bits, u32 table)

#if NO_BG_COLOUR
  ldr r0,Lobjp      @ OBJPaletteMem
  add r0,r0,r2,lsr#3      @ r2 is address which colour we change
#elif HW_COLOUR
  ldrne r0,Lobjp      @ OBJPaletteMem
  addne r0,r0,r2,lsr#3      @ r2 is address which colour we change
  ldreq r0,Lbgp       @ BGPalette mem if changing colour 0 (otherwise we see no change)
#else 
  @ palette buffer
  ldr r0,=palBuf      @ palette buffer
  addne r0,r0,r2,lsr#3 
#endif

  strh  r1,[r0]     @ half word store.. otherwise could use [r0,r2,lsr#3]
  mov   pc,lr

.global evenVideULAWrite
.type evenVideULAWrite,function
evenVideULAWrite:
  @ even write  VideoULA_ControlReg = value
  @ldr    r1,=HSyncModifier
  @tst    r0,#16         @value & 16
  @movne  r2,#8
  @moveq  r2,#16
  @strb   r2,[r1]
  @skip ttxt mode check
  @ store value in control reg
  ldr    r1,=VideoULA_ControlReg       @VideoULA_Palette+4     @VideoULA_ControlReg
  @ldr    r2,[r1]
  strb   r0,[r1]
 
  @  need to reset the scanline function..
  ldr    r1,=scanlineFunction  @LscanlineF
#if defined(ELITE_HACK)
@  tst    r0,#8
@  ldrne  r12,=lowLevelDoScanLine1bpp   @LscanlineF+4
@  ldreq  r12,=lowLevelDoScanLineWide     @LscanlineF+8
@  str    r12,[r1,#0]
#else
  tst    r0,#16
  ldrne  r12,=lowLevelDoScanLineNarrow   @LscanlineF+4
  ldreq  r12,=lowLevelDoScanLineWide     @LscanlineF+8
  str    r12,[r1,#0]
#endif

@.type setCPS,function
@.global setCPS
@setCPS:
@  ldr   r1, CRTCVals
@  ldrb  r2,[r1,#OFFSET_HorizontalTotal]   
@  add    r2,r2,#1
@  moveq  r2,r2,lsl #1    
@  ldr   r1,=cyclesPerScanline
@  strb  r2,[r1]

  @ ttxt screen adjust:
  tst    r0,#2      @ have we entered Teletext mode?
  movne  r0,#1    @ yes
  moveq  r0,#0    @ no
  ldr   r1,=VideoState    @AsmVideoState
  str   r0,[r1,#OFFSET_IsTeletext]  @ store here
  @ r2 = oldvalue, r0 = new value   (removed)
  @ skip video adjust (what it do?)
  bne       clear_non_tt
  @ need to clear teletext if we have just turned it off...
  @ add a test here - maybe we don't need to do this
  ldr    r2,haveClearedTT  
  cmp    r2,#0
  ldr    r1,=clearTeletext
  moveq    r2,#1
  streq    r2,haveClearedTT
  bxeq   r1 
  bx     lr 
  @mov     pc,lr 



Lobjp: .word 0x5000200
Lbgp: .word 0x5000000
.global palBuf
palBuf: .space 2*16     @ 16 colours, 2 bytes each
.global haveClearedTT
haveClearedTT: .space 4     @ 16 colours, 2 bytes each

@Lcolours: .word colours
@LscanlineF: .word scanlineFunction
@.word lowLevelDoScanLineNarrow
@.word lowLevelDoScanLineWide
@LclearTeletext: .word clearTeletext

@ the video state 
@AsmVideoState:  
@  .word VideoState    @<- pointer to videostate
.equ OFFSET_IsTeletext,               12  @This frame is a teletext frame - do things differently 

#if USE_1770_DISC

.global disc1770Read
.type disc1770Read, function
disc1770Read:

    ands  r0,memptr,#0x0f
    @ in the case that r0 is 0, i.e. we read the Drive Control register,
    @ return 0, which means "Drive select 0, side select 0" 
    mov       bbc_nz,#0
    moveq     pc,lr
    @ otherwise we are reading the FDC chip registers
    @ for Watford drives r0 will now contain 4-8 (we hope) - i.e. read 0xfe84-0xfe88
    subs      r0,r0,#4
    movmi     pc,lr      @ unkown read
    cmp       r0,#4
    movgt     pc,lr      @ unknown read
    
    @ read written in arm for speed
    @ int val = 0;  bbc_nz already 0
    adr  r1, L1770jumps
    ldr  pc,[r1,r0,lsl#2]
case1770_0:
    @  ClearNMI();
    ldr  r1,=NMIintStatus
    str  bbc_nz,[r1]
    @  val = status1770;
    ldr  r1,=status1770
    ldr  bbc_nz,[r1]
    mov pc,lr 
    @  break;
case1770_1:
    @  val = trackReg;
    @  break;
    ldr  r1,=trackReg
    ldr  bbc_nz,[r1]
    mov pc,lr 
case1770_2:
    @  val = sector;
    @  break;
    ldr  r1,=sector
    ldr  bbc_nz,[r1]
    mov pc,lr 
case1770_3:
    @if (command1770 > STEP_OUT) {
    ldr  r1,=command1770
    ldr  r1,[r1]
    cmp  r1,#5  @ STEP_OUT
    ldr  r1,=data1770
    ldr  bbc_nz,[r1]
    movmi pc,lr 
    ldr  r1,=status1770
    ldr  r2,[r1]
    bic  r2,r2,#2
    str  r2,[r1]
    mov  r2,#0
    ldr  r1,=NMIintStatus
    str  r2,[r1]
    mov  pc,lr 
    @  ResetStatus(1);
    @  ClearNMI();
    @}
    @ val = data1770;
    @ break;


L1770jumps:
.word case1770_0
.word case1770_1
.word case1770_2
.word case1770_3


.global disc1770Write
disc1770Write:
    ands  r1,memptr,#0x0f
    @ in the case that r0 is 0, i.e. we set the FDC control register,
    @ this doesn't make much sense on a single drive, single sided system,
    @ so just quietly return...
    moveq     pc,lr
    @ otherwise we are writing the FDC chip registers
    @ for Watford drives r0 will now contain 4-8 (we hope) - i.e. write 0xfe84-0xfe88
    subs      r1,r1,#4
    movmi     pc,lr      @ unknown
    cmp       r1,#4
    movgt     pc,lr      @ unknown
    
    @ so it is a valid write, call the C code
    @ r0 = value, r1 = address
    @ i.e. do1770write(u32 value, u32 addr)
    stmfd  sp!,{r3-r11,lr}
    ldr r2,=do1770write     @ in C
    adr lr,0f
    bx  r2
0:
    ldmfd  sp!,{r3-r11,lr}
    mov  bbc_nz, r0
    mov  pc,lr
    


#else

@ disk emulation...
.global disc8271Read
disc8271Read:
#if 1
    and r0,memptr,#0xf
    stmfd  sp!,{r3-r12,lr}
    ldr r1,=do8271read     @ in C
    adr lr,0f
    bx  r1
0:
    ldmfd  sp!,{r3-r12,lr}
    mov  bbc_nz, r0
    mov  pc,lr
#else
    
    ands      r0,memptr,#0xf
    ldreq     bbc_nz, =status
    ldreqsb   bbc_nz,[bbc_nz]
    moveq     pc,lr         @ was 0
    
    ldr     r1,=status
    ldr     r2,[r1]
    cmp     r0,#4
    ldreq   bbc_nz, =datareg
@    moveq   bbc_cycles, #64       @ hacky hack
    biceq   r2,r2,#0xc
    ldreqsb   bbc_nz,[bbc_nz]
    streq     r2,[r1]   @ store new status
    beq     end_disc_read
    
    @ must be 1...
    cmp     r0,#1
    movne     bbc_nz,#0
    movne     pc,lr
    
    @ it really is 1
    biceq   r2,r2,#0x10
    str     r2,[r1]   @ store new status
    ldreq   bbc_nz, =result
    mov     r1,bbc_nz
    ldrsb   bbc_nz,[bbc_nz]
    mov     r0,#0
    str     r0,[r1]   @ set result to 0
    ldr     r1,=status
    
end_disc_read:
    @ update NMI status
    tsts    r2,#8
    ldr     r1,=NMIintStatus
    ldr     r2,[r1]
    biceq   r2,r2,#(16|8)
    orrne   r2,r2,#(8)
    str     r2,[r1]
    mov     pc,lr
    
#endif

.global disc8271Write
disc8271Write:
    and r1,memptr,#0x7
    stmfd  sp!,{r3-r12,lr}
    ldr r2,=do8271write     @ in C
    adr lr,0f
    bx  r2
0:
    ldmfd  sp!,{r3-r12,lr}
    mov  pc,lr

#endif

.global FDCRead
FDCRead:
.global pagedRomRead
pagedRomRead:
.global econetRead
econetRead:
.global unknownRead
unknownRead:
@.global analogRead
@analogRead:
  ldrb        bbc_nz,[bbc_mem,memptr]
  mov   pc,lr

.global analogRead
analogRead:
  @ldrb  bbc_nz,[bbc_mem,memptr]
  mov   bbc_nz,#0x00
  mov   pc,lr

.global tubeRead
tubeRead:
  mov   bbc_nz,#0xfe
  orr   bbc_nz,bbc_nz,#0xfe000000
  mov   pc,lr

@.global userVIAWrite
@userVIAWrite:

.global unknownWrite
unknownWrite:
#if  0
  stmfd       sp!,{r0-r12,lr}
  adr         lr,0f
  mov         r1,memptr
  ldr         r2,=dumpWrite
  bx          r2
0:
  ldmfd       sp!,{r0-r12,lr}
#endif
  ldrb        bbc_nz,[bbc_mem,memptr]
  mov   pc,lr

.global romChangeWrite
romChangeWrite:
  ldr         r2,=PagedRomReg
  ldr         r1,[r2]
  and         r0,r0,#0xf     @ Master bank switching is out
  cmp         r1,r0
  moveq       pc,lr        @ speed hack - don't bother if the same rom
  str         r1,[r2]
  @ check that it's not an empty rom bank either
  ldr         r2,=ROM_BANKS
  add         r2,r2,r0,lsl#2   @*4
  ldr         r2,[r2]
  cmp         r2,#0
  moveq       pc,lr        @ speed hack - don't bother if we don't have the rom
@else load the rom
  stmfd       sp!,{r0-r12,lr}
  adr         lr,0f
  mov         r1,memptr
  ldr         r2,=changeRomBank   @ r0 = new bank, r1 == address
  bx          r2
0:
  ldmfd       sp!,{r0-r12,lr}
  mov   pc,lr

.align 4
@ clear non teletext mode by turning off the sprites
.type clear_non_tt, function
clear_non_tt:
   mov   r0,#0x4000000
   ldr   r1,[r0]
   bic   r1,r1,#0x1000
   str   r1,[r0]
   mov   r0,#0
   str   r0,haveClearedTT
   mov   pc,lr

.global AsmCRTCWrite
.type AsmCRTCWrite,function
@ input r0 = value, r12 = memptr = address to write to
AsmCRTCWrite:
  tst   memptr,#1
@  ldr   r1, CRTCVals

  ldr   r1,=CRTCControl
  beq   evenCRTCWrite   @ eq = Z = not set
@  stmfd sp!,{r3}
  
  adr     r2,LcrtcWriteJumps
  ldr     memptr,[r1,#OFFSET_ControlReg]
  ldr     pc,[r2,memptr,lsl#2]     @ 4 bytes per symbol
  

.global crtcCase0
.type crtcCase0, function
crtcCase0:
  strb  r0,[r1,#OFFSET_HorizontalTotal]
  @cyclesPerScanline = (CRTC_HorizontalTotal+1)*((VideoULA_ControlReg & 16)?1:2);
  ldr    r1,=VideoULA_ControlReg
  ldr    r1,[r1]
  tst    r1,#16
  add    r0,r0,#1
  moveq  r0,r0,lsl #1
  movne  r0,r0,lsl #2
  ldr   r1,=cyclesPerScanline
  str   r0,[r1]
  mov   pc,lr
crtcCase1:
@ this hack fixes Exile disc loading...
@  cmp   r0,#0
@  moveq r0,#80
@ no longer needed - I fixed the renderer when HD = 0
  strb  r0,[r1,#OFFSET_HorizontalDisplayed]
  @ clear out vram 
  @ sorts out several ugly screen transition glitches..
  ldr r0,=zero
  ldr r1,DMA_SRC
  str r0,[r1]
  mov   r1,#0x60
  mov   r0,#0x10000
  orr   r0,r0,r1,lsl#20
  ldr r1,DMA_DST
  str r0,[r1]
  ldr r0,DMA_ON_FIX
  orr r0,r0,#0x8000/4
  ldr r1,DMA_FLG
  str r0,[r1]

  mov   pc,lr
crtcCase4:
  strb  r0,[r1,#OFFSET_VerticalTotal]
  mov   pc,lr
crtcCase5:
  strb  r0,[r1,#OFFSET_VerticalTotalAdjust]
  mov   pc,lr
crtcCase6:
  strb  r0,[r1,#OFFSET_VerticalDisplayed]
  mov   pc,lr
crtcCase9:
  strb  r0,[r1,#OFFSET_ScanLinesPerChar]
  mov   pc,lr
  
crtcCasec:
  @CRTC_ScreenStartHigh=Value;
  strb  r0,[r1,#OFFSET_ScreenStartHigh]
  mov   pc,lr
crtcCased:
  @CRTC_ScreenStartLow=Value;
  strb  r0,[r1,#OFFSET_ScreenStartLow]
  mov   pc,lr
  
crtcCasex:
@  ldmfd sp!,{r3}
  mov   pc,lr
  
evenCRTCWrite:
  @CRTCControlReg = value;
  and   r0,r0,#0x1f
  strb  r0,[r1,#OFFSET_ControlReg]
endCRTC:
  mov   pc,lr
  

@ most of these reads are the serial port thingy, 
@ due to a cock up on my behalf :)
.global AsmCRTCRead
.type AsmCRTCRead,function
@ register memptr holds the address to read
@ returns the value read in bbc_nz
AsmCRTCRead:
  mov   bbc_nz,#0
  mov   pc,lr
  
  

LcrtcWriteJumps:
.word   crtcCase0
.word   crtcCase1
.word   crtcCasex
.word   crtcCasex
.word   crtcCase4   
.word   crtcCase5   
.word   crtcCase6   
.word   crtcCasex   
.word   crtcCasex   
.word   crtcCase9   
.word   crtcCasex
.word   crtcCasex     
.word   crtcCasec   @ set CRTC_ScreenStartHigh 
.word   crtcCased
.word   crtcCasex
.word   crtcCasex

  


@.align 4
@LVideoULA_Palette:
@  .word VideoULA_Palette          @pointer to palette
@  .word VideoULA_ControlReg          
@LHSyncModifier:
@  .word HSyncModifier

.align 4
.extern CRTCControl

.equ  OFFSET_ControlReg           , (0*4)
.equ  OFFSET_HorizontalTotal      , (1*4)
.equ  OFFSET_HorizontalDisplayed  , (2*4)
.equ  OFFSET_HorizontalSyncPos    , (3*4)
.equ  OFFSET_SyncWidth            , (4*4)
.equ  OFFSET_VerticalTotal        , (5*4)
.equ  OFFSET_VerticalTotalAdjust  , (6*4)
.equ  OFFSET_VerticalDisplayed    , (7*4)
.equ  OFFSET_VerticalSyncPos      , (8*4)
.equ  OFFSET_InterlaceAndDelay    , (9*4)
.equ  OFFSET_ScanLinesPerChar     , (10*4)
.equ  OFFSET_CursorStart          , (11*4)
.equ  OFFSET_CursorEnd            , (12*4)
.equ  OFFSET_ScreenStartHigh      , (13*4)
.equ  OFFSET_ScreenStartLow       , (14*4)
.equ  OFFSET_CursorPosHigh        , (15*4)
.equ  OFFSET_CursorPosLow         , (16*4)
.equ  OFFSET_LightPenHigh         , (17*4)
.equ  OFFSET_LightPenLow          , (18*4)

zero : .word 0

DMA_SRC : .word 0x40000D4
DMA_DST : .word 0x40000D8
DMA_FLG : .word 0x40000DC
DMA_ON_FIX: .word 0x85000000


.pool
.end
