#include "menudata.h"
#include "menu.h"

const menu_t g_theMenus[MENU_CNT] = {
  
  {"Change Keys", 
    "Change key mappings and toggle virtual keyboard",
    changeKeys},
  
  {"Video Settings",  
    "Adjust scale and position. Non-teletext modes only",
    videoSettings},
    
  {"Load New UEF",
    "Load a new 'ROM' state",
    doNewGame},
    
  {"Load Disc",     
    "Insert and boot a disc image",
    loadDisc},      /* After resetting, if we press <Shift>
                                          it tries loading stuff! */
  {"Backup",  
    "Load and Save to SRAM",
    doSramMenu},
    
  {"Reset..",      
    "Display the reset options",
    doResetSubmenu},

#if INCLUDE_DEBUG
  {"Debugging",      
    "View PC, registers, etc",
    debugSettings},
#endif
};


#define KEY_OPT_CNT 11
// key options..
const option_t g_keyOptions[] = {
  {"A", 
    "Press A or use left/right to change",
    0,0x6a+0xe},
  {"B",
    "Press A or use left/right to change",
    0,0x6a+0xe},

  {"Select",
    "Press A or use left/right to change",
    0,0x6a+0xe},
  {"Start",
    "Press A or use left/right to change",
    0,0x6a+0xe},

  {"Right",
    "Press A or use left/right to change",
    0,0x6a+0xe},
  {"Left",
    "Press A or use left/right to change",
    0,0x6a+0xe},
  {"Up",
    "Press A or use left/right to change",
    0,0x6a+0xe},
  {"Down",
    "Press A or use left/right to change",
    0,0x6a+0xe},
    
  {"R",
    "Press A or use left/right to change",
    0,0x6a+0xe},
  {"L",
    "Press A or use left/right to change",
    0,0x6a+0xe},
 
  {"VK",
    "A to toggle on/off. Virtual keyboard shown upon menu exit",
    0,0} 
  
};

/*
#define VIDEO_OPT_CNT 5
// video options..
const option_t g_videoOptions[] = {
  {"Scale X",0,256},
  {"Scale Y",0,256},
  
  {"Auto X & Y",0,1},
  
  {"Offset X",0,128},    // -64 to 64
  {"Offset Y",0,128},    // -64 to 64...
  
//  {"Palette",0,2},    // dark to bright...
  
};
*/
#define VIDEO_OPT_CNT 4
const option_t g_videoOptions[] = {
  {"Change Scale",
    "Press A to start changing then use d-pad. B exits",
    0,1},
  {"Change Position",
    "Press A to start changing then use d-pad. B exits",
    0,1},
  {"Fat Pixels",
    "Press A to toggle on/off",
    0,1},
  {"Palette changes",
    "Press A to toggle. Use this hack to 'fix' games with unexpected flashing colours",
    0,1},
};

#define RESET_OPT_CNT 3
const option_t g_resetOptions[] = {
  {"Soft Reset",
    "Resets the BBC without resetting its memory",
    0,1},
  {"Hard Reset",
    "Completely resets the emulated BBC",
    0,1},
  {"Exit",
    "Exit PocketBeeb. Quits to the shell if available",
    0,1},
};

#define SRAM_OPT_CNT 2
const option_t g_sramOptions[] = {
  {"Load State",     
    "Load previous save from SRAM",
    0,0},
  {"Save State",  
    "Save current emu state to SRAM",
    0,0},
};


#define NO_OPT_CNT 1
const option_t g_notDoneOption[] = {
  {"Do Stuff",0,256}
};


const option_t * const g_optionTable [] = {
  g_keyOptions,
  g_videoOptions,
  g_resetOptions,
  g_sramOptions,
  g_notDoneOption,
  g_notDoneOption,
};

const unsigned char g_optionCount[] = {
  KEY_OPT_CNT,
  VIDEO_OPT_CNT,
  RESET_OPT_CNT,
  SRAM_OPT_CNT,
  NO_OPT_CNT,
  NO_OPT_CNT,
};

