.section .iwram,"ax",%progbits
.align 4
.code 32

.extern IC32State

.global  checkKeys
.extern setupMenu
.type checkKeys, function
checkKeys:
  @ check that we need to really do the kb intrupt
  ldr    r1,=needKeyInterrupt   @LneedKeyIR
  ldrb   r0,[r1]
  cmp    r0,#0
  moveq  pc,lr    @ no need
  mov    r2,#0
  str    r2,[r1]
  
  cmp    r0,#4
  @ if == 4, need to show menu
  bne    beebKeyIR
  ldreq   r0,=setupMenu
  bxeq    r0            @ no link - doesn't return
  



.global beebKeyIR
.extern KeysDown
.type beebKeyIR,function
.func beebKeyIR
beebKeyIR:
  @replaces DoKbdIntCheck
  @only push if need be - use regs r0-r2 otherwise

  
  ldr     r2,=IC32State
  ldr     r2,[r2]
  tst     r2,#8
  beq     rowPress      @ if ! &8 then chek rows

  ldr     r2,=KeysDown
  ldr     r0,[r2]        @KeysDown
  cmp     r0,#0
  moveq       pc,lr  @ nothing prssed
  @ we have a key down, but is the sysvia ready?
  ldr   r0,=SysVIAState
  ldrb  r2,[r0,#offset_pcr]
  tst   r2,#4  @ pcr&4 != 0
  @ check IC32State if cmp is a result
  moveq       pc,lr  @ not ready
@ if IC32State&8
.type setKeyIR,function
setKeyIR:
  @stmfd   sp!,{lr}
  ldrb    r2,[r0,#offset_ifr]
  orr     r2,r2,#1
  strb    r2,[r0,#offset_ifr]
  ldr    pc,=IFRTopBitSys
1:
  mov       pc,lr
.type rowPress,function
rowPress:
  @ check a row is pressed
  @ fist, kbdcol must be < 10
  ldr      r1,=KBDCol  @beebKeyboard+16  @KBDCOL
  ldr      r0,[r1]
  cmp      r0,#10
  movpl    pc,lr 
  @ loop over 8 rows and see what's pressed
  ldr      r1,=SysViaKbdState  @beebKeyboard+20  @ sysviakbdstate
  add      r1,r1,r0,lsl#3     @ points to the column
  mov      r0,#7
kbdRowLoop:
  ldrb      r2,[r1,r0]
  cmp       r2,#0
  ldrne     r0,=SysVIAState
  bne       setKeyIR
  subs      r0,r0,#1
  bne       kbdRowLoop
  mov       pc,lr
.endfunc


.global SlowDataBusWrite
.type SlowDataBusWrite,function
@ input r0 value
SlowDataBusWrite:
  @ should store the value to pass to sound.
@  have changed this a bit..
@  stmfd   sp!,{r3,lr}  @ only need to push these if we use 'em
@ i freed up r1 so now I can use it in here.
@ also, safe to use r12 (memptr) as I have already used its value
  str     r0,slowBusValue
  ldr     r2,=IC32State
  ldr     r2,[r2]        @r2 = IC32State
  tst     r2,#8
  bne     0f          @ if set, jump

  @r0 = input value

  mov     r12,r0,lsr#4
  and     r12,r12,#7
  ldr     r1,=KBDRow
  str     r12,[r1]

  and     r12,r0,#15
  ldr     r1,=KBDCol
  str     r12,[r1]
  
@  bl      beebKeyIR      @ fixes many a slow down!!

0:
  tst     r2,#1        @ test bit 0 of IC32State
@  ldmnefd   sp!,{r3,lr}  @ no need to pull these anymore, as we didn't use them
  movne   pc,lr
  
  @ write r0 to sound register (slowBusValue)
  mov    r12,lr
  bl     writeSound
  mov    lr,r12
  mov     pc,lr


.global IC32Write
.type IC32Write, function
IC32Write:
  @ r0 contains the value to write
  @ can use r1, r2, r12
  
  @ first get the bit shift amount:
  and   r1,r0,#7      @r1 = shift value
  mov   r2,#0x1
  mov   r2,r2,lsl r1    @r2 = (1<<bit)

  ldr   r12,=IC32State
  ldrb   r1,[r12]        @r1 = IC32State, r12 = &IC32State

  tst       r0,#8         @ is bit 3 set in new value?
  orrne     r2,r1,r2      @if set (non-zero) then |=
  biceq     r2,r1,r2      @else &= 0xff-(1<<bit)

  strb       r2,[r12]  @ store new IC32 value

  @ now check if we need to do a sound write..
  @ at this point, r1 = old IC32State, r2 = new IC32State
  @ writeSound if (oldValue&1) && !(newValue&1)
  and       r0,r1,#1    @ oldValue
  @ r0 = oldValue&1
  and       r12,r2,#1    @ newValue
  @ r12 = newValue&1
  subs      r12,r12,r0    @ newValue = newValue - oldValue  < if negative then write
  @r12 = new-old....
  @bpl       beebKeyIR
  @bmi       IC32WriteSound
@ key ir only if bit 8 changed 
  @and       r0,r1,#8    @ oldValue
  @and       r12,r2,#8   @ newValue
  @cmp       r12,r0  @ newValue - oldValue  < if not the same, then key test
  @bne       beebKeyIR
  movpl pc,lr
@ else... write sound, as new&1 == 0 and old&1 == 1
IC32WriteSound:
  mov        r12,lr
  ldr        r0,slowBusValue
  bl         writeSound
  mov        lr,r12
  @ big assumption here - if we needed to call sound
  @ then we probably didn't need to check keys.
  @b          beebKeyIR
  mov pc,lr




@AsmSysVIAState:
@.word SysVIAState     @ pointer to SysViaState
@.word dumpIC32Write     

.equ    offset_ora,       0
.equ    offset_orb,       1
.equ    offset_ira,       2
.equ    offset_irb,       3
.equ    offset_ddra,      4
.equ    offset_ddrb,      5
.equ    offset_acr,       6
.equ    offset_pcr,       7
.equ    offset_ifr,       8
.equ    offset_ier,       9


@.word lastKeys
@.word handleKeys

@LslowBusValue:
@.word slowBusValue

.global slowBusValue
.section .iwram,"ax",%progbits
slowBusValue: .space 4

.pool
.end


