#include "MyListBox.h"
#include "UEFLoaderFrame.h"
#include "wx/filename.h"


BEGIN_EVENT_TABLE(MyListBox, wxListBox)
  EVT_KEY_DOWN(MyListBox::OnKeyDown)
END_EVENT_TABLE()

void MyListBox::OnKeyDown(wxKeyEvent & event) {
  if (event.GetKeyCode() == WXK_DELETE) {
    if (m_main != NULL) {
			wxCommandEvent unused_event;
      m_main->RemoveSelected(unused_event);
    }
  } else {
    event.Skip();
  }
}

void MyListBox::RegisterLoader(UEFLoaderFrame * uef) {
  m_main = uef;
}

#if wxUSE_DRAG_AND_DROP
bool MyListBox::OnDropFiles(wxCoord x, wxCoord y,
                             const wxArrayString& filenames) {
  int count = filenames.GetCount();
  if (count) {
    for (int i = 0; i < count; i++) {
      wxFileName fullpath(filenames[i]);
      if (fullpath.HasExt() && 
          ((fullpath.GetExt().CmpNoCase("ssd")==0) || 
           (fullpath.GetExt().CmpNoCase("uef")==0)  )) {
        m_main->AddEntry(fullpath.GetFullPath());
      }
    }
  }
  
  return true;
}
#endif

