#ifndef MyListBox_h_seen
#define MyListBox_h_seen

#include "wx/wx.h"
#if wxUSE_DRAG_AND_DROP
#include "wx/dnd.h"
#endif

class UEFLoaderFrame;
class MyListBox : public wxListBox
#if wxUSE_DRAG_AND_DROP
, public wxFileDropTarget
#endif
{
  public :
    MyListBox(UEFLoaderFrame* parent, wxWindowID id, 
	const wxPoint& pos = wxDefaultPosition, 
	const wxSize& size = wxDefaultSize, 
	int n = 0, 
	const wxString choices[] = NULL, 
	long style = 0, 
	const wxValidator& validator = wxDefaultValidator, 
	const wxString& name = "listBox") :
      wxListBox((wxFrame*)parent, 
	  id, 
	  pos, 
	  size, 
	  n, 
	  choices,
	  style,
	  validator,
	  name ) 
      {m_main = parent;}
    void OnKeyDown(wxKeyEvent & event);
    void RegisterLoader(UEFLoaderFrame *);
#if wxUSE_DRAG_AND_DROP
  virtual bool OnDropFiles(wxCoord x, wxCoord y,
                             const wxArrayString& filenames);
#endif
  protected:
    UEFLoaderFrame *m_main;
  private :
    DECLARE_EVENT_TABLE();
};

#endif
