#ifndef UEFInfo_h_seen
#define UEFEntry_h_seen
#include "wx/wx.h"
#include "wx/ffile.h"
#include "wx/filename.h"

#define KEYS_LENGTH  10
#define HEADER_SIZE  36
class UEFInfo
{

  public:
    UEFInfo();
    UEFInfo(const wxString & fileName, const wxString & userName, int * keys);
    virtual ~UEFInfo();
    unsigned char * UEFInfo::getInfoAsBytes(int realUEFSize);

    void init(
	const wxString & fileName, 
	const wxString & userName, 
	int * keys);


    inline wxString  getFileName() {
      return m_fileName->GetFullName();
    }

    inline wxString & getUserName() {
      return (*m_userName);
    }
    inline void setUserName(const wxString & newUserName) {
      
      if (m_userName)
	*m_userName = newUserName;
      else
	m_userName = new wxString(newUserName);
      if (m_userName->Length() > 11) {
	m_userName->Truncate(11);
	     
      }
/*      else if (m_userName->Length() < 11) {
	m_userName->Pad(11,' ');
      }*/
    }
    inline bool isNull() {
      return isnull != 0;
    }
    int getKey(int keyIndex);
    void setKey(int keyIndex, int value);
    void UEFInfo::write(wxFFile & out);
    static  UEFInfo * UEFInfo::read(wxFFile & in);

  protected :
    int isnull;
    int m_keys[KEYS_LENGTH];
    int xScale;
    int yScale;
    int xOffset;
    int yOffset;

    wxString *m_userName;
    wxFileName *m_fileName;
};
#endif
