//#include <iostream.h>
#include "UEFInfoDialog.h"
#include "UEFLoaderFrame.h"
#include "UEFInfo.h"

#if wxUSE_TOOLTIPS
#include "wx/tooltip.h"
#endif // wxUSE_TOOLTIPS

/*Enumeration for event widgets*/

enum {
  ID_BOX_A=200,
  ID_BOX_B,
  ID_BOX_u,
  ID_BOX_d,
  ID_BOX_l,
  ID_BOX_r,
  ID_BOX_L,
  ID_BOX_R,
  ID_BOX_T,  // start
  ID_BOX_S,  // select
  ID_NAME_TEXT,
  ID_BUTTON_OK,
  ID_BUTTON_CANCEL,
    
};

BEGIN_EVENT_TABLE(UEFInfoDialog, wxDialog)
  EVT_BUTTON(ID_BUTTON_OK, UEFInfoDialog::ok)
  EVT_BUTTON(ID_BUTTON_CANCEL, UEFInfoDialog::cancel)
  EVT_CLOSE(UEFInfoDialog::close)
END_EVENT_TABLE()

const wxString UEFInfoDialog::keynames[KEY_CTRL_COUNT] = {
  "[-OFF-] ",
  "[BACKSP]",
  "[TAB]   ",
  "[CTRL]  ",
  "[CAPS]  ",
  "[ESC]   ",
  "[COPY]  ",
  "[Up]    ",
  "[Down]  ",
  "[Left]  ",
  "[Right] ",
  "[DEL]   ",
  "[SHIFT] ",
  "[RETURN]",
  "[SH.LOC]",
  " ",
  "!",
  "\"",
  "#",
  "$",
  "%",
  "&",
  "\'",
  "(",
  ")",
  "*",
  "+",
  ",",
  "-",
  ".",
  "/",
  "0",
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "8",
  "9",
  ":",
  ";",
  "<",
  "=",
  ">",
  "?",
  "@",
  "A",
  "B",
  "C",
  "D",
  "E",
  "F",
  "G",
  "H",
  "I",
  "J",
  "K",
  "L",
  "M",
  "N",
  "O",
  "P",
  "Q",
  "R",
  "S",
  "T",
  "U",
  "V",
  "W",
  "X",
  "Y",
  "Z",
  "[",
  "\\",
  "]",
  "^",
  "_",
  "F0",
  "F1",
  "F2",
  "F3",
  "F4",
  "F5",
  "F6",
  "F7",
  "F8",
  "F9",
};

UEFInfoDialog::UEFInfoDialog (wxWindow* parent,
                              wxWindowID id,
                              UEFInfo * info) :
wxDialog(parent,(int)id, *(info->getUserName()),wxDefaultPosition ),
m_info(info)
{
  // then createUI!
  createUI();

  // update the UI with the selected values..
  updateUI();

  // have OK and Cancel..

  // as m_info is the pointer, can change actual value passed in.
  m_box_A->SetFocus();
}

void UEFInfoDialog::updateUI() {

  // now the keys
  int index = 0;
  m_box_A->SetSelection(m_info->getKey(index++));
  m_box_B->SetSelection(m_info->getKey(index++));
  m_box_S->SetSelection(m_info->getKey(index++));
  m_box_T->SetSelection(m_info->getKey(index++));
  m_box_r->SetSelection(m_info->getKey(index++));
  m_box_l->SetSelection(m_info->getKey(index++));
  m_box_u->SetSelection(m_info->getKey(index++));
  m_box_d->SetSelection(m_info->getKey(index++));
  m_box_R->SetSelection(m_info->getKey(index++));
  m_box_L->SetSelection(m_info->getKey(index++));
  
  
}

/**
* ui will be key maps, user name, preview picture
*
* name:____________
*
* A [-----]     L [-----]
* B [-----]     R [-----]
* u [-----]     S      ______
* d [-----]     Sl    [     ]
+ l [-----]           [     ]
* r [-----]           [     ]
*                     -------
*/
#define CREATE_BUTTON(but,id,label)  but = new wxButton(this, id, \
    label \
    )

//#define CREATE_COMBO_BOX(cb, id) (cb = new wxChoice(this, id, \
                        keynames[0], wxDefaultPosition, wxDefaultSize, KEY_CTRL_COUNT,\
                        keynames, wxCB_READONLY, wxDefaultValidator, \
                        "comboBox"))

#define CREATE_COMBO_BOX(cb, id) (cb = new wxChoice(this, id, \
                        wxDefaultPosition, wxDefaultSize, KEY_CTRL_COUNT,\
                        keynames))

#define CREATE_TEXT_LABEL(lb, text) wxStaticText * text_##lb = new wxStaticText(this, -1, text \
   , wxDefaultPosition, sizer, wxALIGN_LEFT )


#define CREATE_ROW(rw, text) \
  CREATE_TEXT_LABEL(rw, text); \
  wxSizer *sizerRow_##rw = new wxBoxSizer(wxHORIZONTAL); \
  sizerRow_##rw->Add(text_##rw ,0, wxLEFT, 5);\
  sizerRow_##rw->Add(m_box_##rw ,0, wxRIGHT, 5)



void UEFInfoDialog::createUI() {
  // need to create several large combo boxes..
  CREATE_COMBO_BOX(m_box_A, ID_BOX_A);
  CREATE_COMBO_BOX(m_box_B, ID_BOX_B);
  CREATE_COMBO_BOX(m_box_S, ID_BOX_S);
  CREATE_COMBO_BOX(m_box_T, ID_BOX_T);
  CREATE_COMBO_BOX(m_box_r, ID_BOX_r);
  CREATE_COMBO_BOX(m_box_l, ID_BOX_l);
  CREATE_COMBO_BOX(m_box_u, ID_BOX_u);
  CREATE_COMBO_BOX(m_box_d, ID_BOX_d);
  CREATE_COMBO_BOX(m_box_R, ID_BOX_R);
  CREATE_COMBO_BOX(m_box_L, ID_BOX_L);
  
  CREATE_BUTTON(m_button_OK,ID_BUTTON_OK,"OK");
  CREATE_BUTTON(m_button_Cancel,ID_BUTTON_CANCEL,"Cancel");

  // and then add them to the ui
  wxSizer *sizerTop     = new wxBoxSizer(wxVERTICAL);
  wxSizer *sizerMid     = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer *sizerRbox = new wxBoxSizer(wxVERTICAL);
  wxBoxSizer *sizerLbox = new wxBoxSizer(wxVERTICAL);
  wxSize sizer(40, 20);

  CREATE_ROW(A,"A");
  CREATE_ROW(B,"B");
  CREATE_ROW(S,"Select");
  CREATE_ROW(T,"Start");
  CREATE_ROW(r,"right");
  CREATE_ROW(l,"left");
  CREATE_ROW(u,"up");
  CREATE_ROW(d,"down");
  CREATE_ROW(R,"R");
  CREATE_ROW(L,"L");


  sizerLbox->SetMinSize(150, 0);
  sizerRbox->SetMinSize(150, 0);

  sizerLbox->Add(sizerRow_A, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_B, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_S, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_T, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_r, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_l, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_u, 0, wxRIGHT, 5);
  sizerLbox->Add(sizerRow_d, 0, wxRIGHT, 5);
  sizerRbox->Add(sizerRow_R, 0, wxLEFT, 5);
  sizerRbox->Add(sizerRow_L, 0, wxLEFT, 5);

  sizerRbox->Add(m_button_OK, 0, wxLEFT, 5);
  sizerRbox->Add(m_button_Cancel, 0, wxLEFT, 5);

  m_editName = new wxTextCtrl(this, ID_NAME_TEXT, m_info->getUserName(),
    wxDefaultPosition, wxDefaultSize, wxALIGN_LEFT );

#if wxUSE_TOOLTIPS
  m_editName->SetToolTip("Name shown in GBA menu, 11 characters" );
  m_button_OK->SetToolTip("Accept changes" );
  m_button_Cancel->SetToolTip("Cancel and lose changes" );
#endif
  sizerTop->Add(m_editName, 0, wxGROW | wxRIGHT | wxLEFT,              10);

  sizerMid->Add(sizerLbox,  0, wxGROW | (wxALL & ~wxRIGHT), 10);
  sizerMid->Add(sizerRbox,  0, wxGROW | (wxALL & ~wxLEFT),  10);

  sizerTop->Add(sizerMid,   0, wxGROW | wxALL,              10);

  this->SetSizer(sizerTop);
  sizerTop->Fit(this);

}

void UEFInfoDialog::ok(wxCommandEvent& WXUNUSED(e)) {
  // get keys pressed etc..
  
  int index = 0;
  m_info->setKey(index++, m_box_A->GetSelection());
  m_info->setKey(index++, m_box_B->GetSelection());
  m_info->setKey(index++, m_box_S->GetSelection());
  m_info->setKey(index++, m_box_T->GetSelection());
  m_info->setKey(index++, m_box_r->GetSelection());
  m_info->setKey(index++, m_box_l->GetSelection());
  m_info->setKey(index++, m_box_u->GetSelection());
  m_info->setKey(index++, m_box_d->GetSelection());
  m_info->setKey(index++, m_box_R->GetSelection());
  m_info->setKey(index++, m_box_L->GetSelection());
    
  m_info->setUserName(m_editName->GetLineText(0));
  
  EndModal(wxID_OK);
}
void UEFInfoDialog::cancel(wxCommandEvent& WXUNUSED(e)) {
  EndModal(wxID_CANCEL);
}
//bool UEFInfoDialog::Close(bool force = false) {
void UEFInfoDialog::close(wxCloseEvent& WXUNUSED(e)) {
	wxCommandEvent ce;
  cancel(ce);
}

