


//#if wxUSE_TOOLTIPS
//#include "wx/tooltip.h"
//#endif // wxUSE_TOOLTIPS

//#include "wx/ffile.h"
//#include "wx/filename.h"
#include "UEFEntry.h"
#include "UEFLoaderFrame.h"
#include "UEFInfoDialog.h"
#include "UEFInfo.h"
#include "DataParser.h"
#include "MyListBox.h"
//#include <iostream>
#include <stdio.h>
#include "wx/dir.h"
#include "wx/file.h"

enum {
  ID_DIRBUTTON=3,
  ID_CLRBUTTON,
  ID_REMBUTTON,
  ID_FINISH,
  ID_ALLFILES,
  ID_INFODIALOG,
  ID_BBCGBA,
  ID_FINDBBC,
  ID_MENUGBA,
  ID_FINDMENU,

  ID_SPLASH,
  ID_FINDSPLASH,

};

#include "icon.xpm"
#include "five.xpm"



BEGIN_EVENT_TABLE(UEFLoaderFrame, wxFrame)
  EVT_BUTTON(ID_DIRBUTTON, UEFLoaderFrame::AddDirectory)
  EVT_BUTTON(ID_CLRBUTTON, UEFLoaderFrame::ClearAllFiles)
  EVT_BUTTON(ID_REMBUTTON, UEFLoaderFrame::RemoveSelected)
  EVT_BUTTON(ID_FINISH,    UEFLoaderFrame::CreateFile)
  EVT_BUTTON(ID_FINDBBC,   UEFLoaderFrame::FindBBC)
  EVT_BUTTON(ID_FINDMENU,  UEFLoaderFrame::FindMenu)
  EVT_BUTTON(ID_FINDSPLASH,  UEFLoaderFrame::FindSplash)
  EVT_LISTBOX_DCLICK(ID_ALLFILES, UEFLoaderFrame::DoubleClickList)
//  EVT_CLOSE(UEFLoaderFrame::Close)
END_EVENT_TABLE()


UEFLoaderFrame::UEFLoaderFrame(const wxString& title, const char * arg0)
: wxFrame(NULL, 1, title,wxDefaultPosition,
    wxDefaultSize,wxDEFAULT_FRAME_STYLE|wxTAB_TRAVERSAL)
{
  m_allFiles = new MyListBox(this, ID_ALLFILES,
                           wxDefaultPosition, wxDefaultSize,
                           0, NULL,
                           wxLB_HSCROLL| wxLB_EXTENDED);
#if wxUSE_DRAG_AND_DROP
  SetDropTarget( m_allFiles);
#endif
  // check the exe start dir only
  wxFileName exePath(arg0);
  exePath.Normalize();  // absolute-ize
  m_exeDir = new wxString(exePath.GetPath());
  exePath.Assign(*m_exeDir , "pbeeb.ini");
  m_infoGenerator = new DataParser(exePath.GetFullPath());
  // BoxSizer is the Layout Manager - a horizontal one:
  
  // this is the top level box
  wxSizer *sizerTop     = new wxBoxSizer(wxHORIZONTAL);
  
  // Rbox contains the right hand controls
  wxBoxSizer *sizerRbox = new wxBoxSizer(wxVERTICAL);
  // the buttons controling the list go in here
  wxBoxSizer *sizerRList = new wxBoxSizer(wxVERTICAL);
  // the list and Create button goes in here
  wxBoxSizer *sizerCreatebox = new wxBoxSizer(wxHORIZONTAL);
  // Lbox contains the left hand controls
  wxBoxSizer *sizerLbox = new wxBoxSizer(wxVERTICAL);
  // each of these contains a button/text combo
  wxBoxSizer *sizerIn   = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer *sizerOut  = new wxBoxSizer(wxHORIZONTAL);
  wxBoxSizer *sizerSplash  = new wxBoxSizer(wxHORIZONTAL);

  wxStaticText *listLabel = new wxStaticText(this, -1, "Files to append:",wxDefaultPosition);
  m_lastDir    = new wxString(".");  
  m_addDir     = new wxButton(this, ID_DIRBUTTON , _T("Add Dir"));
  m_remove     = new wxButton(this, ID_REMBUTTON , _T("Remove"));
  m_clear      = new wxButton(this, ID_CLRBUTTON , _T("Clear"));
  //m_finish     = new wxButton(this, ID_FINISH    , _T("Create"));
  wxBitmap bmp1(icon);
  SetIcon(wxIcon(five));

  m_finish     = new wxBitmapButton(this, ID_FINISH    , bmp1);
  m_findBbc    = new wxButton(this, ID_FINDBBC   , _T("Input"));
  m_findMenu   = new wxButton(this, ID_FINDMENU  , _T("Output"));
  
  m_findSplash = new wxButton(this, ID_FINDSPLASH   , _T("Splash"));
  m_splashSelector = new wxCheckBox(this,-1, "Use splash screen");

#if wxUSE_TOOLTIPS
  m_addDir->SetToolTip("Choose a directory with disc images/save states" );
  m_clear->SetToolTip("Clear the list of files");
  m_remove->SetToolTip("Remove selected files");
  m_finish->SetToolTip("Create the emu with the list of games");
  m_findBbc->SetToolTip("Select input file");
  m_findMenu->SetToolTip("Select output file");
  m_allFiles->SetToolTip("List of games to add, double click for controls");
  m_findSplash->SetToolTip("Select PCX image for splash screen");
  m_splashSelector->SetToolTip("Include splash screen");
#endif //wxUSE_TOOLTIPS

  // and a vertical one:
  sizerLbox->Add(listLabel,  0, wxLEFT, 5);
  sizerLbox->Add(m_allFiles, 1, wxGROW | wxALL, 5);


  sizerLbox->SetMinSize(150, 0);
  sizerRbox->SetMinSize(150, 0);
  
  exePath.Assign(*m_exeDir , "bbc.gba");
  m_bbcgba = new wxTextCtrl(this,ID_BBCGBA, exePath.GetFullPath() );
  exePath.Assign(*m_exeDir , "menu.gba");
  m_menugba = new wxTextCtrl(this,ID_MENUGBA, exePath.GetFullPath());
  m_splash = new wxTextCtrl(this,ID_SPLASH, "");
  m_splashSelector->SetValue(false);

  sizerRList->Add(m_addDir, 0, wxBOTTOM, 5);
  sizerRList->Add(m_remove, 0, wxBOTTOM, 5);
  sizerRList->Add(m_clear,  0, wxBOTTOM, 5);
  sizerCreatebox->Add(sizerRList, 0, wxBOTTOM, 5);
  sizerCreatebox->Add(m_finish, 1, wxEXPAND | wxALL, 5);
  sizerIn->Add(m_findBbc,  1, wxRIGHT|wxBOTTOM, 5);
  sizerIn->Add(m_bbcgba,   2, wxBOTTOM|wxADJUST_MINSIZE, 5);
  sizerOut->Add(m_findMenu,1, wxBOTTOM|wxRIGHT,  5);
  sizerOut->Add(m_menugba, 2, wxBOTTOM|wxADJUST_MINSIZE, 5);
  sizerSplash->Add(m_findSplash,1, wxBOTTOM|wxRIGHT,  5);
  sizerSplash->Add(m_splash, 2, wxBOTTOM|wxADJUST_MINSIZE, 5);
  
  sizerRbox->Add(sizerCreatebox,  0, wxRIGHT | wxEXPAND, 0);
  sizerRbox->Add(sizerIn,  0, wxRIGHT, 0);
  sizerRbox->Add(sizerOut, 0, wxRIGHT, 0);
  sizerRbox->Add(sizerSplash, 0, wxRIGHT, 0);
  sizerRbox->Add(m_splashSelector, 2, wxBOTTOM|wxADJUST_MINSIZE, 5);

  
  sizerTop->Add(sizerLbox, 0, wxGROW | (wxALL & ~wxLEFT), 10);
  sizerTop->Add(sizerRbox, 0, wxGROW | (wxALL & ~wxLEFT), 10);

  this->SetAutoLayout(TRUE);
  this->SetSizer(sizerTop);
  sizerTop->Fit(this);
  m_all = new ArrayOfUEFEntry;

  readOptionFile();
  
  m_addDir->SetFocus();
  this->Show(TRUE);
}

UEFLoaderFrame::~UEFLoaderFrame() {
  writeOptionFile();
  m_infoGenerator->closeAndSave();
  removeAllEntries();
  delete m_exeDir;
  delete m_infoGenerator;
  delete m_lastDir;
}

void UEFLoaderFrame::removeAllEntries() {
  //Erase previous entries copied to the vector.
  ArrayOfUEFEntry::iterator iter = m_all->begin();

  while (iter != m_all->end())  {
    delete *iter;
    ++iter;
  }
  m_all->clear();
}
/*
void UEFLoaderFrame::Close(wxCloseEvent & force) {
  if (force) {
    Destroy();
    return TRUE;
  } else {
    return FALSE;
  }
}*/

void UEFLoaderFrame::ClearAllFiles(wxCommandEvent& WXUNUSED(e)) {
  // clear all files from the window
  m_allFiles->Clear();
  removeAllEntries();
}

bool UEFLoaderFrame::inList(const wxString & f) {
  ArrayOfUEFEntry::iterator allIt = m_all->begin();
  while (m_all->end() != allIt) {
    UEFEntry & oneEntry = **allIt;
    
    wxFileName fullpath(oneEntry.toString());
    if (fullpath.GetFullName().Cmp(f) == 0) {
      return true;
    }
    allIt++;
  }
  return false;

}

bool UEFLoaderFrame::AddEntry(const wxString & file) {
  wxFileName fullpath(file);
  if (!inList(fullpath.GetFullName())) {

    // check that the file is addable...
    wxFFile tmpFile;
    if (wxFileExists(file) && 
       tmpFile.Open(file,"rb"))
    {
      size_t tmpLength = tmpFile.Length();
      // append a file to the binary
      if (tmpLength != 0) {
	unsigned char * tmp = (unsigned char*) malloc(tmpLength);
	tmpFile.Seek(0);
	tmpFile.Read(tmp,tmpLength);
	tmpLength = m_infoGenerator->trimStateData(tmp,tmpLength);
	free(tmp);
      }
      if (tmpLength != 0) {
	UEFEntry * newEntry = new UEFEntry(fullpath.GetFullPath(),m_infoGenerator);
	m_infoGenerator->setInfo(newEntry->info());
	m_all->push_back(newEntry);
	m_allFiles->Append(fullpath.GetFullName());
	return true;
      } 
    }     
  } 
  return false;
}

void UEFLoaderFrame::AddDirectory(wxCommandEvent& WXUNUSED(e)) {
  // show a dir dialog...
  const wxString& dir = wxDirSelector("Choose a folder",*m_lastDir,0);
  if ( !dir.empty() )
  {
    wxDir d(dir);
    int skipped = 0;
    if (d.IsOpened()) {
      *m_lastDir = dir;
      wxString fileSpec("*.uef");
      wxString file;
      wxFileName fullpath;
      for (int i = 0; i < 2; i ++) {
	if (i == 1) {
	  fileSpec = "*.ssd";
	}
	bool cont = d.GetFirst(&file, fileSpec, wxDIR_FILES);
	while( cont ) {
	  fullpath.Assign(dir,file);
	  /*if (!inList(file)) {
	    newEntry = new UEFEntry(fullpath.GetFullPath(),m_infoGenerator);
	    m_infoGenerator->setInfo(newEntry->info());
	    m_all->push_back(newEntry);
	    m_allFiles->Append(file);
	  } else {
	    */
	  if (!AddEntry(fullpath.GetFullPath())) {
	    skipped++;
	  }
	  cont = d.GetNext(&file);
	}
      }
#if 0
      if (skipped != 0) {
	wxString f("Skipped ");
	f << skipped << " files in this directory";
	wxMessageBox(f,"Info", wxOK|wxICON_INFORMATION);
      }
#endif
    }
  }

}


void UEFLoaderFrame::DoubleClickList(wxCommandEvent & theEvent) {
  // user double clicks the all files list
  // get selected item and show modal dialog box
  if (m_allFiles->GetCount()) {

    int selectedItem = theEvent.m_commandInt;
    // traverse list of UEFEntries to get dbl clicked one
    ArrayOfUEFEntry::iterator allIt = m_all->begin();
    int currIndex = 0;

    while (m_all->end() != allIt && currIndex < selectedItem) {
      allIt++;
      currIndex++;
    }

    UEFEntry & oneEntry = **allIt;
    UEFInfo * uei = oneEntry.info();
    //UEFInfoDialog infoDlg(this, ID_INFODIALOG, oneEntry.info());
    UEFInfoDialog infoDlg(this, ID_INFODIALOG, uei);
    infoDlg.ShowModal();
    m_infoGenerator->setInfo(uei);
  }


}

void UEFLoaderFrame::RemoveSelected(wxCommandEvent& WXUNUSED(e)) {
  if (m_allFiles->GetCount()) {

    // traverse list of UEFEntries, remove selected ones
    ArrayOfUEFEntry::iterator allIt = m_all->begin();

    int currIndex = 0;
    while (m_all->end() != allIt) {
      if (m_allFiles->Selected(currIndex) ) {
        delete *allIt;
        allIt = m_all->erase(allIt);
        m_allFiles->Delete(currIndex);
//        currIndex;
      } else {
        allIt++;
        currIndex++;
      }
    }
    m_all->resize(currIndex);
  }

}

int UEFLoaderFrame::getCount(const wxString & mask) {
  ArrayOfUEFEntry::iterator iter = m_all->begin();
  int count = 0;
  while (iter != m_all->end())  {
    UEFEntry & oneEntry = **iter;
    UEFInfo * uei = oneEntry.info();
    if (uei->getFileName().Matches(mask)) {
      count ++;
    }
    iter++; 
  }
  return count;

}

void UEFLoaderFrame::CreateFile(wxCommandEvent& WXUNUSED(e)) {
  // create the output file
  // finish off the app
  // concatonate all files to the gba file  
  // output to menu.gba
  // read in gba file
  /*if (wantedUEFEntries == null || wantedUEFEntries.length == 0) {
    JOptionPane.showMessageDialog(this, "Select some games to add!\nClick on 'Open Directory'", 
	"Information", JOptionPane.INFORMATION_MESSAGE);
    return;
  }*/
  wxString s_gbaFile = m_bbcgba->GetLineText(0);
  wxString s_menuFile = m_menugba->GetLineText(0);

  wxFFile gbaFile;

  if ( !wxFileExists(s_gbaFile) || gbaFile.Open(s_gbaFile,"rb") == FALSE) {
    wxMessageBox("A problem with the input gba file...\n" \
	"Make sure you've chosen the right one!", 
	"Information", wxOK|wxICON_ERROR );
    return;
  }
  size_t gbaLength = gbaFile.Length();

  // check if the file exists, ask for confirmation...
  if (wxFileExists(s_menuFile)) { 
    if (wxYES != wxMessageBox("Chosen output file exists... overwrite it?",
	  "Overwrite?", wxYES_NO | wxCANCEL| wxICON_QUESTION,this))
      return;
  }
  // now see if we can write to it 
  wxFFile m(s_menuFile,"wb");
  if (m.IsOpened() != TRUE) {
    wxMessageBox("Unable to write to the chosen output file",
	"Information", wxOK|wxICON_ERROR);
    return;
  }
  
  for (;;) {
    unsigned char * gba = (unsigned char*) malloc(gbaLength);
    char nullBytes[4] = {0,0,0,0};
    int brokenUEFs = 0;
    gbaFile.Seek(0);
    gbaFile.Read(gba,gbaLength);
    m.Write(gba,gbaLength - 8);

    free(gba);

    wxString splash(m_splash->GetLineText(0));
      
    // write 4 bytes less - 2 are the SSD count, 2 are the UEF count
    // get count of each being added... write here
    int uefs =  getCount("*.uef"); 
    int ssds =  getCount("*.ssd"); 
    if (splash.empty() || !m_splashSelector->GetValue()) {
      m.Write(nullBytes, 4);
      // the .gba reads from end -2, end -4 to get the values...
      m.Write((unsigned char*)&uefs, 2);
      m.Write((unsigned char*)&ssds, 2);
    } else {
      wxFFile sf(splash,"rb");
      if (sf.IsOpened()  == TRUE) {
	size_t sl = sf.Length();
	m.Write((unsigned char*)&sl, 4);
	// the .gba reads from end -2, end -4 to get the values...
	m.Write((unsigned char*)&uefs, 2);
	m.Write((unsigned char*)&ssds, 2);
	unsigned char * sfd  = (unsigned char*) malloc(sl);
	sf.Seek(0);
	sf.Read(sfd,sl);

	m.Write(sfd,sl);
	gbaLength += sl;
	if (0 != (sl&3)) {
	  int tmpLength = 4-(sl&3);
	  gbaLength += tmpLength; 
	  m.Write(nullBytes,tmpLength);
	}

      } else {
	m.Write(nullBytes, 4);
	// the .gba reads from end -2, end -4 to get the values...
	m.Write((unsigned char*)&uefs, 2);
	m.Write((unsigned char*)&ssds, 2);
      }

    }


    // read in uefs... create a header for each:
    // size, keys etc
    int totalSize = gbaLength;
    bool allOK = true;
    ArrayOfUEFEntry::iterator iter = m_all->begin();

    wxFFile tmpFile;
    while (iter != m_all->end())  {
      //printf( "file at %x \n",totalSize);
      // UEFEntry.toString gives the FILE NAME and PATH, not just the catalogue name
      if (tmpFile.Open((*iter)->toString(),"rb") == TRUE) {
	UEFInfo *uei = m_infoGenerator->getInfo((*iter)->info()->getFileName());
	size_t tmpLength = tmpFile.Length();
	// append a file to the binary
	unsigned char * tmp = (unsigned char*) malloc(tmpLength);
	tmpFile.Seek(0);
	tmpFile.Read(tmp,tmpLength);
	tmpLength = m_infoGenerator->trimStateData(tmp,tmpLength);
	unsigned char * header = uei->getInfoAsBytes(tmpLength);

	wxString  isUEF = uei->getFileName();
	isUEF = isUEF.SubString(isUEF.Length()-3,isUEF.Length());
	isUEF.MakeLower();
	if (isUEF.Cmp("ssd") == 0) {
	  header[27] = 1;
	} else {
	  header[27] = 2;
	}

	m.Write(header,HEADER_SIZE);
	m.Flush();
	m.Write(tmp,tmpLength);
	free(tmp);
	free(header);

	// pad to 4 byte boundary...
	totalSize += tmpLength;
	totalSize += HEADER_SIZE;
	if (0 != (totalSize&3)) {
	  tmpLength = 4-(totalSize&3);
	  totalSize += tmpLength; 
	  m.Write(nullBytes,tmpLength);
	}
      } else {
	allOK = false;
	break;
      }
      ++iter;
    }
    if (!allOK) break;

    wxMessageBox("File created successfully", 
	"Information", wxOK|wxICON_EXCLAMATION);
    return;
  } 
  // an error.. 
  wxMessageBox( "Uh-oh, unable to write all or part of the output file!\n"\
      "Make sure you have permission to write in the chosen output file \n"\
      "and that all the chosen input files still exist!",
      "Information", wxOK,this);
}

void UEFLoaderFrame::FindBBC(wxCommandEvent& WXUNUSED(e)){
  // find the bbc.gba file
  wxFileName fn( m_bbcgba->GetLineText(0));
  const wxString& file = wxFileSelector("Choose the emulation file", 
      fn.GetPath(),
       "bbc.gba", "gba", "*.gba", wxOPEN|wxFILE_MUST_EXIST);

  //cout << "file ="<<file<<"#"<<endl;
  if (!file.empty()) {
    m_bbcgba->Clear();
    m_bbcgba->WriteText(file);
  }// else cancelled
}
void UEFLoaderFrame::FindMenu(wxCommandEvent& WXUNUSED(e)){
  // set the output menu.gba file
  wxFileName fn( m_menugba->GetLineText(0));
  const wxString& file = wxFileSelector("Choose the output file", 
      fn.GetPath(),
       "menu.gba", "gba", "*.gba", wxSAVE);

//  cout << "file ="<<file<<"#"<<endl;
  if (!file.empty()) {
    m_menugba->Clear();
    m_menugba->WriteText(file);
  }// else cancelled
}

void UEFLoaderFrame::FindSplash(wxCommandEvent& WXUNUSED(e)){
  // set the output menu.gba file
  wxFileName fn( m_splash->GetLineText(0));
  const wxString& file = wxFileSelector("Choose the output file", 
      fn.GetPath(),
       "", "pcx", "*.pcx", wxOPEN);

  if (!file.empty()) {
    m_splash->Clear();
    m_splash->WriteText(file);
  }// else cancelled
}


wxString UEFLoaderFrame::optionFileName = "pbinject.cfg";
void  UEFLoaderFrame::readOptionFile() {
  
  wxFileName optionFilePath(*m_exeDir , optionFileName );
  if (wxFileExists(optionFilePath.GetFullPath())) {
    wxFFile opts(optionFilePath.GetFullPath(),"r");

    // search current dir
    if (opts.IsOpened()) {
      // read in each line
      size_t length = opts.Length();
      char * optc = (char*) malloc(length);
      opts.Read(optc, length);
      size_t index = 0;

      m_bbcgba->Clear();
      m_menugba->Clear();
      m_lastDir->Clear();

      wxTextCtrl * txtctrl;
      for (int property = 0; property < 3; property++) {
	if (property == 0) {
	  txtctrl = m_bbcgba;
	} else if (property == 1) {
	  txtctrl = m_menugba;
	} else if (property == 2) {
	  txtctrl = m_splash;
	}
	while (optc[index] != '\n' && index < length) {
	  (*txtctrl) << optc[index];
	  index++;
	} 
	index++;
      }
      while (optc[index] != '\n' && index < length) {
	(*m_lastDir) << optc[index];
	index++;
      } 
      free(optc);
    } 
  } 
}
void  UEFLoaderFrame::writeOptionFile() {
  
  wxFileName optionFilePath(*m_exeDir , optionFileName );
  wxFFile opts;
  
  if (wxFile::Access(optionFilePath.GetFullPath(), wxFile::write)) {
    opts.Open(optionFilePath.GetFullPath(),"w");

    // search current dir
    if (opts.IsOpened()) {
      // write each line
      size_t length = opts.Length();
      char * optc = (char*) malloc(length);
      opts.Read(optc, length);
      //int index = 0;
      char nl[2]; nl[0] = '\n'; nl[1] = 0; 
      opts.Write(m_bbcgba->GetLineText(0).c_str());
      opts.Write(nl);
      opts.Write(m_menugba->GetLineText(0).c_str());
      opts.Write(nl);
      opts.Write(m_splash->GetLineText(0).c_str());
      opts.Write(nl);
      opts.Write(m_lastDir->c_str());
      opts.Write(nl);

    } 
  }
}


