#ifndef UEFLoaderFrame_h_seen
#define UEFLoaderFrame_h_seen
#include "wx/wx.h"
#include <vector>

class UEFEntry;
class DataParser;
class MyListBox;
typedef std::vector<UEFEntry*> ArrayOfUEFEntry;

class UEFLoaderFrame : public wxFrame
{
public:
  UEFLoaderFrame(const wxString& title, const char *);
  ~UEFLoaderFrame();

  //virtual void Close(wxCloseEvent&);
  void RemoveSelected(wxCommandEvent &);
  bool UEFLoaderFrame::AddEntry(const wxString & file) ;

protected:
  wxButton * m_addDir;
  wxButton * m_clear;
  wxButton * m_remove;
  wxBitmapButton * m_finish;
  //wxButton * m_finish;
  DataParser * m_infoGenerator;

  MyListBox *m_allFiles;

  // the list of all file entries
  ArrayOfUEFEntry * m_all;
  wxTextCtrl *m_bbcgba;
  wxButton * m_findBbc;
  wxTextCtrl *m_menugba;
  wxButton * m_findMenu;
  wxString * m_lastDir;
  //UEFEntry * m_all;
  static wxString optionFileName;
  wxString * m_exeDir;
  
  wxTextCtrl *m_splash;
  wxButton * m_findSplash;
  wxCheckBox * m_splashSelector;

  void removeAllEntries();

  // event handlers:
  void AddDirectory(wxCommandEvent &);
  void ClearAllFiles(wxCommandEvent &);
  void DoubleClickList(wxCommandEvent & );
  void CreateFile(wxCommandEvent &);
  void FindBBC(wxCommandEvent &);
  void FindMenu(wxCommandEvent &);
  void FindSplash(wxCommandEvent &);
  bool inList(const wxString & f);
  int getCount(const wxString & mask);
  void  readOptionFile();
  void  writeOptionFile();

private:
    DECLARE_EVENT_TABLE()

};
#endif
