
#include "pogo.h"
#include "gba.h"
#include "bbcdisc.h"
#include "inter.h"
#include "fastvideo.h"
#include "gfx.h"
#include "savestate.h"
#include "sysvia.h"
#include "input.h"

#define MAX_UEF_SIZE 98600

int g_isPogoshell = 0;
unsigned long g_pogoAddr = 0;
unsigned long g_pogoUeforssd = 0;
void checkPogoShell(void) {
  g_pogoUeforssd = 0;
  g_isPogoshell = 0;
  if (POGO_COOKIE[0] == POGO_MAGIC) {
    g_pogoAddr = POGO_ADDR[0];
    if ((g_pogoAddr&0xfe000000) == 0x08000000) {
      g_isPogoshell = 1;

      char *s = POGO_NAME;
      do s++; while(*s); // skip plugin name
      do s++; while(*s); // skip file path/name
      s -= 3; // get extension
      // check extension
      if ((s[0]&~0x20) == 'U' && 
	  (s[1]&~0x20) == 'E' &&
	  (s[2]&~0x20) == 'F'
	 ) 
      {
	// UEF
	g_pogoUeforssd = 1;
      } else if (
	  (s[0]&~0x20) == 'S' && 
	  (s[1]&~0x20) == 'S' &&
	  (s[2]&~0x20) == 'D'
	  ) 
      {
	// SSD
	g_pogoUeforssd = 2;
      }
    }

  }
}

extern int shiftDownFrames;
void loadFromPogo() {

  REG_IME = 0;
  if (g_pogoUeforssd == 1) {
    LoadUEFState((unsigned char *)g_pogoAddr, (unsigned char*) (g_pogoAddr + MAX_UEF_SIZE) );
  }
  else if (g_pogoUeforssd == 2) {
    discs  = (unsigned char*)g_pogoAddr;
    REG_INTERUPT = (u32)loadingIR;
    copyColours = COPY_COLOURS;
    shiftDownFrames = 180;
    SysViaKbdState[0][0] = 1;
    KeysDown = 1;
    needKeyInterrupt = 1;
  }
  REG_IME = 1;
}

