#include "keypad.h"
#include "screenmode.h"
#include "menudata.h"
#include "gfx.h"

extern FunctionPtr leftHandler;
extern FunctionPtr rightHandler;

FunctionPtr upHandler = 0;
FunctionPtr downHandler = 0;

int vs_increment = 0;
int vs_repeated[4] = {};
void video_settings_keyhandler(void) {
  for (;;) {
    wait_vsync_int();
    UpdateKeys();
    //vs_increment = KeyPressed(KEY_L)?5:1;
    if ( KeyPressedNoBounce(KEY_RIGHT,5) ) {
      vs_repeated[0]++;
      vs_increment = vs_repeated[0];
      rightHandler();
    } else if ( !KeyPressed(KEY_RIGHT) ) {
      vs_repeated[0] = 0;
    }

    if ( KeyPressedNoBounce(KEY_LEFT,5) ) {
      vs_repeated[1]++;
      vs_increment = vs_repeated[1];
      leftHandler();
    } else if ( !KeyPressed(KEY_LEFT) ) {
      vs_repeated[1] = 0;
    }
    
    if ( KeyPressedNoBounce(KEY_UP,5) ) {
      vs_repeated[2]++;
      vs_increment = vs_repeated[2];
      upHandler();
    } else if ( !KeyPressed(KEY_UP) ) {
      vs_repeated[2] = 0;
    }
    if ( KeyPressedNoBounce(KEY_DOWN,5) ) {
      vs_repeated[3]++;
      vs_increment = vs_repeated[3];
      downHandler();
    } else if ( !KeyPressed(KEY_DOWN) ) {
      vs_repeated[3] = 0;
    }
    if ( KeyPressedNoBounce(KEY_B,5) ) {
      break;
    }
  }
}

void position_left(void) {
  adjustOffset(-vs_increment,0);
}
void position_right(void) {
  adjustOffset(vs_increment,0);
}
void position_up(void) {
  adjustOffset(0,-vs_increment);
}
void position_down(void) {
  adjustOffset(0,vs_increment);
}

void change_video_position(void) {
  // change the video position
  leftHandler = position_left;
  rightHandler = position_right;
  upHandler = position_up;
  downHandler = position_down;
  clearText();
  video_settings_keyhandler();
}

void scale_left(void) {
  if (rotData[0].pa) {
    if (sprites[0].attribute0 & SIZE_DOUBLE)
      setSpriteScreen(rotData[0].pa+vs_increment,0);
    else
      setSpriteScreenHalfWidth(rotData[0].pa+vs_increment,0);

#if defined(ELITE_HACK)
    setEliteScanner();
#endif
  }
}
void scale_right(void) {
  if (rotData[0].pa) {
    if (sprites[0].attribute0 & SIZE_DOUBLE)
      setSpriteScreen(rotData[0].pa-vs_increment,0);
    else
      setSpriteScreenHalfWidth(rotData[0].pa-vs_increment,0);
#if defined(ELITE_HACK)
    setEliteScanner();
#endif
  }
}
void scale_up(void) {
  if (rotData[0].pd) {
    if (sprites[0].attribute0 & SIZE_DOUBLE)
      setSpriteScreen(0,rotData[0].pd+vs_increment);
    else
      setSpriteScreenHalfWidth(0,rotData[0].pd+vs_increment);
#if defined(ELITE_HACK)
    setEliteScanner();
#endif
  }
}
void scale_down(void) {
  if (rotData[0].pd) {
    if (sprites[0].attribute0 & SIZE_DOUBLE)
      setSpriteScreen(0,rotData[0].pd-vs_increment);
    else
      setSpriteScreenHalfWidth(0,rotData[0].pd-vs_increment);
#if defined(ELITE_HACK)
    setEliteScanner();
#endif
  }
}
void change_video_scale(void) {
  // change the video scale
  leftHandler = scale_left;
  rightHandler = scale_right;
  upHandler = scale_up;
  downHandler = scale_down;
  clearText();
  video_settings_keyhandler();
}

