

.section .iwram,"ax",%progbits
.align 4
.code 32


@ teletext screen in asm...

#define    FONT_TILE   3
#define    xpos   r0
#define    ypos   r1
#define    char   r2

#define    ram    r3
#define    bgcol  r4
#define    fgcol  r5
#define    horiz  r6
#define    index  r7

#define    textfg  r8
#define    textbg  r9
#define    isgfx  r10

.extern CRTC_ScreenStartHigh
.extern VideoState

.type asm_teletext,function
.global asm_teletext
asm_teletext:
  @ push regs used
  stmfd  sp!,{r0-r12,lr}
  @int tmphigh=CRTC_ScreenStartHigh;
  ldr    r1,=CRTCControl
  ldr    r0,[r1,#OFFSET_ScreenStartHigh]                 @hi
  ldr    r1,[r1,#OFFSET_ScreenStartLow]              @lo
  eor    r0,r0,#0x20
  add    r0,r0,#0x74
  ldr    r2,=VideoState
  orr    r0,r1,r0,lsl#8
  strh   r0,[r2,#4]       @ bytes to Addr
  
  @ r0 now holds the start address (offset into ram)
  add    ram,r0,r11   @ whole ram
  @ r4 now points to start of screen
  
@  int x,y;
   @ldr     horiz,=CRTC_HorizontalDisplayed
   ldr     horiz,=CRTCControl
   ldr     horiz,[horiz, #OFFSET_HorizontalDisplayed]
   cmp     horiz,#0
   beq     finishTeletext
   mov     xpos,#0
   mov     ypos,#0
   mov     index,#0
@  int fgcolour = 7;
   mov     fgcol,#7
   mov     isgfx,#0
   str     isgfx,doubleRow
@  int bgcolour = 0;
@  int b;
   ldr    textfg,=bg_teletextfg
   ldr    textfg,[textfg,#4]        @ start of tile data
   ldr    textbg,=bg_teletextbg
   ldr    textbg,[textbg,#4]        @ start of tile data
  
@  for (y = 0; y < 32 && y <CRTC_VerticalDisplayed; y++) {
@    bgcolour = 0;
vertText:
     mov   bgcol,#0
     mov   isgfx,#0
horizText:

@    for (x = 0;  x < CRTC_HorizontalDisplayed; x++) {
      @ print a row of text
      @b = WholeRam[VideoState.Addr+x+y*CRTC_HorizontalDisplayed]&0xff;
      ldrb       char,[ram,index]
      @ get the colour:
      @ if (b<32) b+=128; // fix for naughty programs that use 7-bit control codes - Richard Gellman
      cmp        char,#0x20
      addmi      char,char,#0x80

@      tst        char, #32
@      cmpne      isgfx,#0
@      strne      char,holdGfxChar
      @if (b <= 135 && b >= 129) 
      @  fgcolour = b - 128;
      cmp        char,#129
      bmi        doPrintText
      cmp        char,#0xff
      moveq      char,#98  
      beq         endCharOffset
@ is a special char...
      cmp        char,#136
      submi      fgcol,char,#128
      movmi      isgfx,#0
      bmi        endLoop
      @ else > 135...  
      @if (b == 157)
      @  bgcolour = fgcolour;
      cmp        char,#157
      moveq      bgcol,fgcol
      beq        endLoop
      @if (b == 156)
      @  bgcolour = 0;

      cmp        char,#140
      moveq      isgfx,#0
      beq        endLoop

      cmp        char,#141
      beq        doubleH

      cmp        char,#156
      moveq      bgcol,#0
      beq        endLoop

      cmp        char,#158
      moveq      char,#1
      streq      char,holdGfx
      beq        endLoop
      cmp        char,#159
      moveq      char,#0
      streq      char,holdGfx
      beq        endLoop
 
      cmp        char,#145
      bmi        endLoop
      cmp        char,#151        
      bpl        endLoop
      mov        isgfx,#96  
      sub        fgcol,char,#144

@      stmfd      sp!,{r0}
@      ldr        r0,holdGfx
@      cmp        r0,#0
@      ldrneb      char,holdGfxChar
@      moveq      char,#32
@      ldmfd      sp!,{r0}
      
@ FIXME here, for other opcodes
      b          endLoop
doPrintText:      
      @if (b < 128 ) {
      @ load r0,r1,r2 with x,y, fg col, r3 is already the char
      @   print_teletext(b&0x7f,x,y,fgcolour);
      @ change order of print teletext...
      @ instead of calling this function, better off just writing direct
      @ to bg_teletextfg.mapdata[x+y*32] = (FONT_TILE + char -0x20) | fgcol<<12
      cmp    char,#0
      beq    endLoop
@      cmp    isgfx,#0
      add  char,char,isgfx
      sub  char,char,#(0x20-FONT_TILE)

@      addne  char,char,#(96+FONT_TILE-0x20)

endCharOffset:
      add    r12,textfg,ypos,lsl#6   @ *32 * 2 cos of 2 bytedness
      add    r12,r12,xpos,lsl#1    @ *2 cos of 2 bytes
      orr    char,char,fgcol,lsl#12
      strh   char,[r12]
      @ load r0,r1,r2 with x,y, bg col, r3 is already the char
      add    r12,textbg,ypos,lsl#6   @ *32 * 2 cos of 2 bytedness
      add    r12,r12,xpos,lsl#1    @ *2 cos of 2 bytes
      mov    char,#(FONT_TILE + '~'-0x20 +1)     @ the character after tilde is a square blob
      orr    char,char,bgcol,lsl#12
      strh   char,[r12]
      @   print_teletextbg(x,y,bgcolour);
      @ }
       
endLoop:
      add   xpos,xpos,#1
      add   index,index,#1
      cmp   xpos,#32   @ we are forced to the width of our tile map.
      bne   horizText 
      mov   xpos,#0
      sub   index,index,#32
      add   index,index,horiz
@ hardware wrap around teletext memory:
      add   char, index, ram         @ char = index + ram = 0x20007xxx, etc
      sub   char,char,r11            @ char = 0x7xxx
      cmp   char,#0x8000             @ have we wrapped? 
      addcs char,char,#0x7c00        @if so... char += 0x7c00
      ldrcs index,memMask            
      andcs char,char,index          @ char = (0x8000 + 0x7c00)&0x7fff
      addcs char,char,r11            @
      subcs index,char,ram           @ char += 0x20000000 - original ram val
@ end wrap around
      
      add   ypos,ypos,#1
      cmp   ypos,#20      @ really should be CRTC_VerticalTotal, but like that'll fit
      bmi   vertText 
@  we are done
.global finishTeletext
.type finishTeletext,function
finishTeletext:
     ldmfd  sp!,{r0-r12,lr}
     mov    pc,lr
    @}
  @}
  @//VideoState.CharLine = CRTC_VerticalTotal;
@}

doubleH:
      stmfd sp!,{r0}
      ldr   r0,doubleRow
      cmp   r0,#0
      moveq isgfx,#96*2
      movne isgfx,#96*3
      eor   r0, r0, #1
      str   r0,doubleRow
      ldmfd sp!,{r0} 
      b      endLoop
memMask: .word 0x7fff
holdGfxChar: .space 4
holdGfx: .space 4
doubleRow: .space 4

.equ  OFFSET_HorizontalDisplayed  , (2*4)
.equ  OFFSET_ScreenStartHigh      , (13*4)
.equ  OFFSET_ScreenStartLow       , (14*4)
.pool
.end

