#include "via.h"
#include "uservia.h"
#include "sysvia.h"

void LoadViaUEF(const unsigned char * const SUEF) {
    VIAState *VIAPtr;
    int VIAType;
    int i = 0; 
    VIAType = (int)SUEF[i++]; 
    if (VIAType) 
      VIAPtr=&UserVIAState; 
    else 
      VIAPtr=&SysVIAState;
    
    VIAPtr->orb=SUEF[i++];
    VIAPtr->irb=SUEF[i++];
    VIAPtr->ora=SUEF[i++];
    VIAPtr->ira=SUEF[i++];
    VIAPtr->ddrb=SUEF[i++];
    VIAPtr->ddra=SUEF[i++];
    VIAPtr->timer1c=SUEF[i]|(SUEF[i+1]<<8); i+=2;
    VIAPtr->timer1l=SUEF[i]|(SUEF[i+1]<<8); i+=2;
    VIAPtr->timer2c=SUEF[i]|(SUEF[i+1]<<8); i+=2;
    VIAPtr->timer2l=SUEF[i]|(SUEF[i+1]<<8); i+=2;
    VIAPtr->acr=SUEF[i++];
    VIAPtr->pcr=SUEF[i++];
    VIAPtr->ifr=SUEF[i++];
    
    VIAPtr->ier=SUEF[i++];
    
    VIAPtr->timer1hasshot=SUEF[i++];
    VIAPtr->timer2hasshot=SUEF[i++];
    if (!VIAType) IC32State=SUEF[i++];
}


void VIAReset(VIAState *ToReset) {
  ToReset->ora=ToReset->orb=0xff;
  ToReset->ira=ToReset->irb=0xff;
  ToReset->ddra=ToReset->ddrb=0;
  ToReset->acr=0;
  ToReset->pcr=0;
  ToReset->ifr=0;
  ToReset->ier=0x80;
  ToReset->timer1l=ToReset->timer2l=0xffff;
  ToReset->timer1c=ToReset->timer2c=0xffff;
  ToReset->timer1hasshot=0;
  ToReset->timer2hasshot=0;
  ToReset->timer2adjust=0;
}

